// Attempt to rewrite Bubble2.java to avoid jumping
// of drawing method as well as control frame speed
//
// Author:   Peter Sonnek
// Date:     10/13/06
// Location: University of Mississippi
//
// Last Time Edidted: 06/19/08

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.MemoryImageSource;
import java.lang.*;
import static java.lang.Math.*;
import java.util.*;
import java.io.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;
import javax.imageio.*;
import javax.imageio.stream.*;
import javax.imageio.plugins.jpeg.JPEGImageWriteParam;

public class Bubble3 {
	
	// Main event
	private static Bubble3 bubble;
	
	// Declare Variables to be used
	private Runoptions runoptions;
	private Distance distance;
	private Mouse mouse;
	private Plist[] plist;
	private P[] p;
	private Farbe[] colortable = new Farbe[216];
	private int pcount;
	private Circlefit circlefit = new Circlefit();
	private FpfdList[] fpfdList = new FpfdList[20];
	private Fpfd2List[] fpfd2List = new Fpfd2List[20];
	private MyZoom zoom = new MyZoom();
	private int ctrEnergyTag = 0, ctrMuonTag = 0;
	private boolean external = false;
	private float[] ecal = new float[123840];
	private float[] hcal = new float[14880];
	
	// Define Constants
	private static final int lengthOfParticleList = 50;
	private static final int maxNumberOfParticles = 1000;
	private static final int LAMBDADECAY = 1;
	private static final int SINGLEPARTICLE = 0;
	private static final int HIGGSDECAY = 2;
	private static final int EXTERNALDATA = 3;
	private static final float PI = (float)3.141592653589;
	 
	// Declare Graphic components
	private static JFrame frame;
	private JPanel buttons;
	private MyCanvas canvas;
	private JButton bNewRun;
	private JButton bRerun;
	private JButton bStop;
	private JButton bShuffleColors;
	private IdentifyTrackClass pnlFindParticle = new IdentifyTrackClass();
	private SingleParticleClass pnlSingleParticle;
	private EnergyTag[] lblEnergyTag = new EnergyTag[10];
	private MuonTag[] lblMuonTag = new MuonTag[10];
	private SingleParticleMessage pnlSingleParticleMessage;
	private JLabel spCurrentParticle = new JLabel();
	private JLabel lblHiggsDecay = new JLabel();
	
	private MemoryImageSource canvasbuffer;
	private Image pixelbuffer;
	private int[] pixels;

	// Menu Items
	private JMenuBar bar;
	private JMenu fileMenu, mouseMenu, analysisMenu, aboutMenu;
	private JMenuItem miProperties, miSaveImage, miQuit;
	private JMenuItem miCirclefit, miZoom, miDistance, miAngle, miIdentifyTrack;
	private JMenuItem miFindParticleFromDecay, miParticleLegend, miViewSupportedParticles;
	private JMenuItem miAbout;

	// Thread Stopping Booleans
	private boolean runOrbitThread = false;
	private boolean runScreenThread = false;	

	// Action listeners for buttons on Bubble panel.
	private ActionListener hNewRun, hRerun, hStop, hButtons;
	
	// Menu Bar Actionlistener
	private ActionListener hMenubar;
	
	// Mouse Adaprors
	private MyMouseHandler hMouse = new MyMouseHandler();
	private MyMouseMotionHandler hMouseMotion = new MyMouseMotionHandler();
	
	// Key Adaptor
	private MyKeys hMyKeys = new MyKeys();
	
    // Properties panel and components.
	private static JFrame frmProperties;
	private JTabbedPane tabbedPane;
	
	private JPanel event;
	private JLabel selectcollisions;
	private JComboBox selectcollisionschoices;
	private JLabel initialpositionx;
	private JTextField initialpositionxtf;
	private JLabel initialpositiony;
	private JTextField initialpositionytf;
	private JLabel initialmomentumx;
	private JTextField initialmomentumxtf;
	private JLabel initialmomentumy;
	private JTextField initialmomentumytf;
	private JButton bPpRun, bPpReset;
	
	private JPanel chambersettings;
	private JLabel magneticfield;
	private JTextField magneticfieldtf;
	private JLabel distancestepping;
	private JTextField distancesteppingtf;
	private JLabel energyloss;
	private JTextField energylosstf;
	private JButton bPpApply, bPpChamberReset;
	
	// Supported particles panel and component.
	private static JFrame frmSupportedParticles;
	private JScrollPane spScrollPane;
	private JTextArea spTextArea = new JTextArea();

	// Particle legend panel and component.
	private static JFrame frmParticleLegend;
	private ParticleLegend pnlParticleLegend = new ParticleLegend();
	private JScrollPane plTextArea = new JScrollPane(pnlParticleLegend);
	
	// Find Particles From Decay Window
	private static JFrame frmFindParticleFromDecay;
	private JLabel fpfdlbMomentumx, fpfdlbMomentumy, fpfdlbRestmass;
	private JLabel fpfdlbDistanceTraveled, fpfdlbRadius, fpfdlbRestmassAnswer;
	private JLabel fpfdlbLifetime;
	private JList fpfdlstParticles;
	private DefaultListModel fpfdlstModel;
	private JTextField fpfdtxtMomentumx, fpfdtxtMomentumy, fpfdtxtRestmass;
	private JTextField fpfdtxtDistanceTraveled, fpfdtxtRadius, fpfdtxtRestmassAnswer;
	private JTextField fpfdtxtLifetime;
	private JButton fpfdbtnAdd, fpfdbtnRemove, fpfdbtnCalculate, fpfdbtnClear;
	private JComboBox comMomenta;

	// Find Particles From Decay Window for Higgs Decay
	private static JFrame frmFindHiggs;
	private JLabel fpfd2lbAngle, fpfd2lbMass, fpfd2lbEnergy, fpfd2lbHiggsmass, fpfd2lblEta;
	private JTextField fpfd2txtAngle, fpfd2txtMass, fpfd2txtEnergy, fpfd2txtHiggsmass, fpfd2txtEta;
	private JList fpfd2lstParticles;
	private DefaultListModel fpfd2lstModel;
	private JButton fpfd2btnAdd, fpfd2btnRemove, fpfd2btnClear, fpfd2btnCalculate;
	private JComboBox comMomenta2;

	// About Window
	private static JFrame frmAbout;
	private JButton aboutbtnOk;
	private JLabel aboutlblPicture, aboutlblText;
	
	// Ecal and Hcal
	CalorimeterWindow frmEcalWindow, frmHcalWindow;

	private void init() {
		
		JFrame.setDefaultLookAndFeelDecorated(true);
		frame = new JFrame("Bubble Chamber v1.1");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(850,730);
		frame.setLayout(new FlowLayout());

		//Create menubar for Bubble.
		bar = new JMenuBar();
		hMenubar = new MenubarHandler();
		frame.setJMenuBar(bar);

		buttons = new JPanel();
		buttons.setLayout(new FlowLayout());
		hButtons = new ButtonsHandler();
		frame.add(buttons);
				
		bNewRun = new JButton("New Run");
		bNewRun.addActionListener(hButtons);
		buttons.add(bNewRun);

		bRerun = new JButton("Rerun");
		bRerun.addActionListener(hButtons);
		buttons.add(bRerun);

		bStop = new JButton("Stop");
		bStop.addActionListener(hButtons);
		buttons.add(bStop);
		
		bShuffleColors = new JButton("Shuffle Colors");
		bShuffleColors.addActionListener(hButtons);
		buttons.add(bShuffleColors);

		canvas = new MyCanvas();
		canvas.setPreferredSize(new Dimension(800,600));
		canvas.addMouseListener(hMouse);
		canvas.addMouseMotionListener(hMouseMotion);
		frame.add(canvas);
		
		pixels = new int[800*600];
		for (int i=0; i<800*600; i++) {
			pixels[i] = 0xffffffff;
		}
		canvasbuffer = new MemoryImageSource(800, 600, pixels, 0, 800);
		canvasbuffer.setAnimated(true);
		canvasbuffer.setFullBufferUpdates(true);
		pixelbuffer = Toolkit.getDefaultToolkit().createImage(canvasbuffer);

		canvas.setLayout(null);
		pnlFindParticle.setSize(new Dimension(40,20));
		pnlFindParticle.setOpaque(true);
		pnlFindParticle.setVisible(false);
		canvas.add(pnlFindParticle);		
		Insets insets = canvas.getInsets();
		pnlFindParticle.setBounds(100 + insets.left,70 + insets.top,61,31);
		
		runoptions = new Runoptions();
		distance = new Distance();
		circlefit = new Circlefit();
		mouse = new Mouse();
		plist = new Plist[lengthOfParticleList];
		for (int i = 0; i<lengthOfParticleList; i++) {
			plist[i] = new Plist();
		}
		bubble.loadParticleList();

		pnlSingleParticle = new SingleParticleClass();
		canvas.add(pnlSingleParticle);
		pnlSingleParticle.setBounds(610 + insets.left, 10 + insets.top, 180,128);
		pnlSingleParticleMessage = new SingleParticleMessage();
		pnlSingleParticleMessage.setBounds(10 + insets.left,10 + insets.top, 500,60);
		canvas.add(pnlSingleParticleMessage);
		spCurrentParticle.setVisible(false);
		canvas.add(spCurrentParticle);	
		
		lblHiggsDecay.setForeground(Color.blue);
		lblHiggsDecay.setText("Single Particle In External Magnetic Field");
		frame.add(lblHiggsDecay);			

		Cursor hourglassCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
		canvas.setCursor(hourglassCursor);

		for (int i=0; i<10; i++) {
			lblEnergyTag[i] = new EnergyTag();
			lblMuonTag[i] = new MuonTag();
		}

		p = new P[maxNumberOfParticles];
		for (int i = 0; i<maxNumberOfParticles; i++) {
			p[i] = new P();
		}
		for (int i=0; i<216; i++) {
			colortable[i] = new Farbe();
		}
		for (int i = 0; i<20; i++) {
			fpfdList[i] = new FpfdList();
		}
		for (int i = 0; i<20; i++) {
			fpfd2List[i] = new Fpfd2List();
		}

		// Set Runoptions
		runoptions.selectedevent = HIGGSDECAY;
		runoptions.inposx = 0; 
		runoptions.inposy = (float) -1.4;
		runoptions.inmomx = 0;
		runoptions.inmomy = 2;
		runoptions.dedx = (float) 0.1;
		runoptions.dl = (float) 0.0001;
		runoptions.b = -2;
		runoptions.replay = false;
		runoptions.scaled = 200;
		runoptions.mustrunnew = true;
		runoptions.isbackground = false;
		runoptions.showgrid = true;
		runoptions.zoombackground = true;
		runoptions.bgimage = "backsingle.jpg";
		mouse.mode = 1;
		
		// Create "File" menu and add items.
		fileMenu = new JMenu("File");
		miProperties = new JMenuItem("Event Type");
		miProperties.addActionListener(hMenubar);
		fileMenu.add(miProperties);
		miSaveImage = new JMenuItem("Save Image");
		miSaveImage.addActionListener(hMenubar);
		fileMenu.add(miSaveImage);
		miQuit = new JMenuItem("Quit");
		miQuit.addActionListener(hMenubar);
		fileMenu.add(miQuit);
	
		// Create "Mouse" menu and add items.
		mouseMenu = new JMenu("Mouse");
		miCirclefit = new JMenuItem("Circle Fit");
		miCirclefit.addActionListener(hMenubar);
		mouseMenu.add(miCirclefit);
		miZoom = new JMenuItem("Zoom");
		miZoom.addActionListener(hMenubar);
		mouseMenu.add(miZoom);
		miDistance = new JMenuItem("Distance");
		miDistance.addActionListener(hMenubar);
		mouseMenu.add(miDistance);
		miIdentifyTrack = new JMenuItem("Identify Track");
		miIdentifyTrack.addActionListener(hMenubar);
		mouseMenu.add(miIdentifyTrack);
		miAngle = new JMenuItem("Angle");
		miAngle.addActionListener(hMenubar);
		mouseMenu.add(miAngle);
	
		// Create "Analysis" menu and add items.
		analysisMenu = new JMenu("Analysis");
		miFindParticleFromDecay = new JMenuItem("Find particle from decay");
		miFindParticleFromDecay.addActionListener(hMenubar);			
		analysisMenu.add(miFindParticleFromDecay);	
		miParticleLegend = new JMenuItem("View particle legend");
		miParticleLegend.addActionListener(hMenubar);		
		analysisMenu.add(miParticleLegend);
		miViewSupportedParticles = new JMenuItem("View supported particles");
		miViewSupportedParticles.addActionListener(hMenubar);		
		analysisMenu.add(miViewSupportedParticles);
	
		// Create About Tab
		aboutMenu = new JMenu("About");
		miAbout = new JMenuItem("About");
		miAbout.addActionListener(hMenubar);
		aboutMenu.add(miAbout);
				
		// Add "File", "Mouse", and "Analysis" menus to the menubar.
		bar.add(fileMenu);
		bar.add(mouseMenu);
		bar.add(analysisMenu);
		bar.add(aboutMenu);

//-----------------------------------------------------------------------------
		// Create Properties Frame;
		frmProperties = new JFrame("Properties");
		frmProperties.setSize(425,217);
		tabbedPane = new JTabbedPane();
		event = new JPanel();
		event.setLayout(new GridLayout(6,2));
	
		selectcollisions = new JLabel("Event Type:");
		event.add(selectcollisions);
		
		String[]s = {"Single Particle in B-Field", "K- + p -> pi- + lambda + pi+", "Higgs -> w+ w- or Z Z"};
		selectcollisionschoices = new JComboBox(s);
		selectcollisionschoices.addActionListener(hButtons);
		event.add(selectcollisionschoices);
		
		initialpositionx = new JLabel("Initial position x(m):");
		event.add(initialpositionx);
		initialpositionxtf = new JTextField(25);
		initialpositionxtf.setText(Float.toString(runoptions.inposx));
		event.add(initialpositionxtf);

		initialpositiony = new JLabel("Initial position y(m):");
		event.add(initialpositiony);
		initialpositionytf = new JTextField(25);
		initialpositionytf.setText(Float.toString(runoptions.inposy));
		event.add(initialpositionytf);
		
		// Create x and y initial momentum labels and textfields and add them to "Event" panel.
		initialmomentumx = new JLabel("Initial momentum x(GeV/c):");
		event.add(initialmomentumx);
		initialmomentumxtf = new JTextField(25);
		initialmomentumxtf.setText(Float.toString(runoptions.inmomx));
		event.add(initialmomentumxtf);

		initialmomentumy = new JLabel("Initial momentum y(GeV/c):");
		event.add(initialmomentumy);
		initialmomentumytf = new JTextField(25);
		initialmomentumytf.setText(Float.toString(runoptions.inmomy));
		event.add(initialmomentumytf);
	
		// Create and add buttons to "Event" panel.
		bPpRun = new JButton("Update Values / Run");
		bPpRun.addActionListener(hButtons);
		event.add(bPpRun);

		bPpReset = new JButton("Reset");
		bPpReset.addActionListener(hButtons);
		event.add(bPpReset);
	
		// Create "Chamber Settings" panel and give it grid layout.
		chambersettings = new JPanel();
		chambersettings.setLayout(new GridLayout(4,2));
	
		// Create and add magentic field label and textfield and add to "Chamber Settings" panel.
		magneticfield = new JLabel("Magnetic field (T):");
		chambersettings.add(magneticfield);
		magneticfieldtf = new JTextField(25);
		magneticfieldtf.setText(Float.toString(runoptions.b));
		chambersettings.add(magneticfieldtf);
	
		// Create and add distance stepping field label and textfield and add to "Chamber Settings" panel.
		distancestepping = new JLabel("Distance stepping (m):");
		chambersettings.add(distancestepping);
		distancesteppingtf = new JTextField(25);
		distancesteppingtf.setText(Float.toString(runoptions.dl));
		chambersettings.add(distancesteppingtf);
	
		// Create and add energy loss label and textfield and add to "Chamber settings" panel.
		energyloss = new JLabel("Energy loss (MeV/m):");
		chambersettings.add(energyloss);
		energylosstf = new JTextField(25);
		energylosstf.setText(Float.toString(runoptions.dedx));
		chambersettings.add(energylosstf);
	
		// Create and add buttons to "Chamber settings" panel.
		bPpApply = new JButton("Apply");
		bPpApply.addActionListener(hButtons);
		chambersettings.add(bPpApply);

		bPpChamberReset = new JButton("Reset");
		bPpChamberReset.addActionListener(hButtons);
		chambersettings.add(bPpChamberReset);
		
		// Add the tabs for the panels.
		tabbedPane.addTab("Event", event);
		tabbedPane.addTab("Chamber settings", chambersettings);
		
		// Add the panels.
		frmProperties.add(tabbedPane, BorderLayout.CENTER);
//-----------------------------------------------------------------------------

		// Create Supported Particles
		frmSupportedParticles = new JFrame("Supported particles");
		frmSupportedParticles.setSize(420,200);
		spScrollPane = new JScrollPane(spTextArea);
		frmSupportedParticles.add(spScrollPane);
//-----------------------------------------------------------------------------

		// Create Particle Legend
		frmParticleLegend = new JFrame("Particle Legend");
		frmParticleLegend. setSize(200,200);
		frmParticleLegend.add(plTextArea);
//-----------------------------------------------------------------------------		

		// Create Find Particle From Decay Form
		frmFindParticleFromDecay = new JFrame("Find Particle From Decay");
		frmFindParticleFromDecay.setSize(400,400);

		JPanel mainPanel = new JPanel();
		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
		frmFindParticleFromDecay.add(mainPanel);

		JPanel panel1 = new JPanel();
		mainPanel.add(panel1);
		panel1.setLayout(new GridLayout(0,2,5,5));
		fpfdlbMomentumx = new JLabel("  Momen. (GeV/c) x:");
		panel1.add(fpfdlbMomentumx);
		fpfdtxtMomentumx = new JTextField(15);
		fpfdtxtMomentumx.setEditable(false);
		panel1.add(fpfdtxtMomentumx);
		fpfdlbMomentumy = new JLabel("  Momen. (GeV/c) y:");
		panel1.add(fpfdlbMomentumy);
		fpfdtxtMomentumy = new JTextField(15);
		fpfdtxtMomentumy.setEditable(false);
		panel1.add(fpfdtxtMomentumy);
		fpfdlbRestmass = new JLabel("  Restmass (GeV/c^2):");
		panel1.add(fpfdlbRestmass);
//		fpfdtxtRestmass = new JTextField(15);
//		fpfdtxtRestmass.addKeyListener(hMyKeys);
//		panel1.add(fpfdtxtRestmass);
//--------------------------------------------
		JPanel panel11 = new JPanel();
		panel11.setLayout(new GridLayout(1,2));
		fpfdtxtRestmass = new JTextField(15);
		fpfdtxtRestmass.addKeyListener(hMyKeys);
		panel11.add(fpfdtxtRestmass);
		comMomenta = new JComboBox();
		for (int i=0; i<lengthOfParticleList; i++) {
			if (!(plist[i].name.equals(""))) {
				comMomenta.addItem(plist[i].name);
			}
			else break;
		}
		comMomenta.addActionListener(hButtons);
		panel11.add(comMomenta);
		panel1.add(panel11);
//--------------------------------------------
		fpfdlbDistanceTraveled = new JLabel("  Dist. Traveled (m):");
		panel1.add(fpfdlbDistanceTraveled);
		fpfdtxtDistanceTraveled = new JTextField(15);
		fpfdtxtDistanceTraveled.setEditable(false);
		panel1.add(fpfdtxtDistanceTraveled);
		fpfdlbRadius = new JLabel("  Radius (m):");
		panel1.add(fpfdlbRadius);
		fpfdtxtRadius = new JTextField(15);
		fpfdtxtRadius.setEditable(false);
		panel1.add(fpfdtxtRadius);
		
		fpfdlstModel = new DefaultListModel();
		fpfdlstParticles = new JList(fpfdlstModel);
        fpfdlstParticles.setVisibleRowCount(4);
		fpfdlstParticles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scrolableList = new JScrollPane(fpfdlstParticles);
		mainPanel.add(scrolableList);

		JPanel panel2 = new JPanel();
		mainPanel.add(panel2);
		fpfdbtnAdd = new JButton("Add");
		fpfdbtnAdd.addActionListener(hButtons);
		panel2.add(fpfdbtnAdd);
		fpfdbtnRemove = new JButton("Remove");
		fpfdbtnRemove.addActionListener(hButtons);
		panel2.add(fpfdbtnRemove);
		fpfdbtnCalculate = new JButton("Calculate");
		fpfdbtnCalculate.addActionListener(hButtons);
		panel2.add(fpfdbtnCalculate);
		fpfdbtnClear = new JButton("Clear");
		fpfdbtnClear.addActionListener(hButtons);
		panel2.add(fpfdbtnClear);
		
		JPanel panel3 = new JPanel();
		panel3.setLayout(new GridLayout(0,2,5,5));
		mainPanel.add(panel3);
		fpfdlbRestmassAnswer = new JLabel("  Restmass (Gev/c^2):");
		panel3.add(fpfdlbRestmassAnswer);
		fpfdtxtRestmassAnswer = new JTextField(15);
		fpfdtxtRestmassAnswer.setEditable(false);
		panel3.add(fpfdtxtRestmassAnswer);
		fpfdlbLifetime = new JLabel("  Decaytime T (ns):");
		panel3.add(fpfdlbLifetime);
		fpfdtxtLifetime = new JTextField(15);
		fpfdtxtLifetime.setEditable(false);
		panel3.add(fpfdtxtLifetime);

		frmFindParticleFromDecay.pack();
 		frmFindParticleFromDecay.setSize(360,360);

//-----------------------------------------------------------------------------

		//Create Find Higgs Window		
		frmFindHiggs = new JFrame("Mass Calculator");
		frmFindHiggs.setSize(400,400);

		JPanel mainPanel2 = new JPanel();
		mainPanel2.setLayout(new BoxLayout(mainPanel2, BoxLayout.Y_AXIS));
		frmFindHiggs.add(mainPanel2);
		
		JPanel panel4 = new JPanel();
		mainPanel2.add(panel4);
		panel4.setLayout(new GridLayout(0,2,5,5));
		fpfd2lbAngle = new JLabel("  Angle Phi (deg):");
		panel4.add(fpfd2lbAngle);
		fpfd2txtAngle = new JTextField(15);
		fpfd2txtAngle.setEditable(false);
		panel4.add(fpfd2txtAngle);
		fpfd2lblEta = new JLabel("  Eta:");
		panel4.add(fpfd2lblEta);
		fpfd2txtEta = new JTextField(15);
		fpfd2txtEta.setEditable(false);
		panel4.add(fpfd2txtEta);
		fpfd2lbEnergy = new JLabel("  Energy (GeV):");
		panel4.add(fpfd2lbEnergy);
		fpfd2txtEnergy = new JTextField(15);
		panel4.add(fpfd2txtEnergy);
		fpfd2lbMass = new JLabel("  Mass (GeV/c^2):");
		panel4.add(fpfd2lbMass);
//		fpfd2txtMass = new JTextField(15);
//		fpfd2txtMass.addKeyListener(hMyKeys);
//		panel4.add(fpfd2txtMass);
//-----------------------
		JPanel panel12 = new JPanel();
		panel12.setLayout(new GridLayout(1,2));
		fpfd2txtMass = new JTextField(5);
		fpfd2txtMass.addKeyListener(hMyKeys);
		panel12.add(fpfd2txtMass);
		comMomenta2 = new JComboBox();
		for (int i=0; i<lengthOfParticleList; i++) {
			if (!(plist[i].name.equals(""))) {
				comMomenta2.addItem(plist[i].name);
			}
			else break;
		}
		comMomenta2.addActionListener(hButtons);
		panel12.add(comMomenta2);
		panel4.add(panel12);
//------------------------

		fpfd2lstModel = new DefaultListModel();
		fpfd2lstParticles = new JList(fpfd2lstModel);
        fpfd2lstParticles.setVisibleRowCount(4);
		fpfd2lstParticles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scrolableList2 = new JScrollPane(fpfd2lstParticles);
		mainPanel2.add(scrolableList2);
		
		JPanel panel5 = new JPanel();
		mainPanel2.add(panel5);
		fpfd2btnAdd = new JButton("Add");
		fpfd2btnAdd.addActionListener(hButtons);
		panel5.add(fpfd2btnAdd);
		fpfd2btnRemove = new JButton("Remove");
		fpfd2btnRemove.addActionListener(hButtons);
		panel5.add(fpfd2btnRemove);
		fpfd2btnCalculate = new JButton("Calculate");
		fpfd2btnCalculate.addActionListener(hButtons);
		panel5.add(fpfd2btnCalculate);
		fpfd2btnClear = new JButton("Clear");
		fpfd2btnClear.addActionListener(hButtons);
		panel5.add(fpfd2btnClear);

		JPanel panel6 = new JPanel();
		mainPanel2.add(panel6);
		panel6.setLayout(new GridLayout(0,2,5,5));
		fpfd2lbHiggsmass = new JLabel("  Higgs Mass (GeV/c^2):");
		panel6.add(fpfd2lbHiggsmass);
		fpfd2txtHiggsmass = new JTextField(15);
		fpfd2txtHiggsmass.setEditable(false);
		panel6.add(fpfd2txtHiggsmass);

		frmFindHiggs.pack();
		frmFindHiggs.setSize(360,275);
//-----------------------------------------------------------------------------

		// Create About Window
		
		String aboutstrText = new String();
		
		frmAbout = new JFrame("About");
		frmAbout.setSize(new Dimension(400,400));

		JPanel mainPanel3 = new JPanel();
		mainPanel3.setLayout(new BoxLayout(mainPanel3, BoxLayout.Y_AXIS));
		mainPanel3.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		frmAbout.add(mainPanel3);

		JPanel panel7 = new JPanel();
		panel7.setLayout(new BoxLayout(panel7, BoxLayout.X_AXIS));
		ImageIcon image = new ImageIcon("pics/about.jpg");
		aboutlblPicture = new JLabel(image);
		aboutlblPicture.addMouseListener(hMouse);
		panel7.add(aboutlblPicture);
		panel7.add(Box.createRigidArea(new Dimension(10,0)));
		aboutstrText += "<html>Bubble Chamber<br><br>Version 1.1 for Java<br><br>";
		aboutstrText += "The Bubble Chamber Program is aimed to teach basic<br>";
		aboutstrText += "principles of particle physics to students by simulating<br>";
		aboutstrText += "events that occur in bubble chambers.<br><br>";
		aboutstrText += "This Program was written by Steve Case and Peter<br>";
		aboutstrText += "Sonnek <a href=mailto:peter@phy.olemiss.edu>(peter@phy.olemiss.edu)</a> at the Univerity of<br>";
		aboutstrText += "Mississippi.<br><br><center>(c) 2007</center></html>";
		aboutlblText = new JLabel(aboutstrText);
		panel7.add(aboutlblText);
		mainPanel3.add(panel7);
		
		mainPanel3.add(Box.createRigidArea(new Dimension(0,10)));
		JPanel panel8 = new JPanel();
		aboutbtnOk = new JButton("OK");
		aboutbtnOk.addActionListener(hButtons);
		panel8.add(aboutbtnOk);
		mainPanel3.add(panel8);
		
		frmAbout.pack();		

//-----------------------------------------------------------------------------
// Create Coloriemeters

		frmHcalWindow = new CalorimeterWindow("HCAL", hcal, 120);
		frmHcalWindow.setGridSpacing3D(15, 15);
		frmHcalWindow.setGridSpacingFlat(15, 15);
		frmHcalWindow.setZoom(4);
		frmHcalWindow.setEnergySelectionGridSize(8, 8);
		frmEcalWindow = new CalorimeterWindow("ECAL", ecal, 344);
		frmEcalWindow.setGridSpacing3D(48, 48);
		frmEcalWindow.setGridSpacingFlat(48, 48);
		frmEcalWindow.setEnergySelectionGridSize(5, 5);

//-----------------------------------------------------------------------------

		bubble.loadColors();
		bubble.changeEvent();

		// Display the window.
		if (!(external)) frame.setVisible(true);
	}

	private void saveImage(String filename) {
		if(!(filename.equals("null") || filename.equals("nullnull"))){
/*			try {
				FileOutputStream fos = new FileOutputStream(filename);
				BufferedImage bi = new BufferedImage(800,600,BufferedImage.TYPE_INT_RGB);
				Graphics g = bi.getGraphics();
//				Image image = java.awt.Toolkit.getDefaultToolkit().createImage(canvasbuffer);
				g.drawImage(pixelbuffer,0,0,frame);
				JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(fos);
				encoder.encode(bi);
				fos.close();
			}
			catch (IOException e){} 
			
			try {
				BufferedImage bi = new BufferedImage(800,600,BufferedImage.TYPE_INT_RGB);
				Graphics g = bi.getGraphics();
				g.drawImage(pixelbuffer,0,0,frame);
				ImageIO.write(bi,"jpg",new File(filename));
			}
			catch (IOException e) {}  */

			System.out.println("Saved Image to " + filename);
			try {
				ImageWriter writer = null;
				Iterator iter = ImageIO.getImageWritersByFormatName("jpg");
				if (iter.hasNext()) {
					writer = (ImageWriter)iter.next();
				}

				ImageOutputStream ios = ImageIO.createImageOutputStream(new File(filename));
				writer.setOutput(ios);
    
				ImageWriteParam iwparam = new JPEGImageWriteParam(Locale.getDefault());
				iwparam.setCompressionMode(ImageWriteParam.MODE_EXPLICIT) ;
				iwparam.setCompressionQuality(1F);
    
				BufferedImage bi = new BufferedImage(800,600,BufferedImage.TYPE_INT_RGB);
				Graphics g = bi.getGraphics();
				g.drawImage(pixelbuffer,0,0,frame);

				writer.write(null, new IIOImage(bi, null, null), iwparam);
    
				ios.flush();
				writer.dispose();
				ios.close();
			}
			catch (IOException e) {}
		}
	}

	void fillParticleLegend() {
		int i;
		String s = new String();
		
		for (i=0; i<=pcount; i++) {
			if (p[i].makespath) s = "   --------   ";
			else s = "                 ";
			if (!(p[i].farbe.r == 192 && p[i].farbe.g == 192 && p[i].farbe.b == 193)) pnlParticleLegend.addParticle(s + p[i].type + " (m = " + Float.toString(p[i].m) + ")", p[i].farbe.r, p[i].farbe.g ,p[i].farbe.b);
		}
	}

	private void clearAllListAndFields() {
			bubble.fpfdClear();
			bubble.fpfd2Clear();
			pnlSingleParticle.clear();
			pnlParticleLegend.clearPanel();
	}

	private void fpfd2Remove() {
	
		int lsti = fpfd2lstParticles.getSelectedIndex();
		if (lsti > -1) {

			int a = 0;
			
			for (int i=0; i<fpfd2lstModel.getSize();i++) {
				if (!(i == lsti)) {
					fpfd2List[a].energy = fpfd2List[i].energy;
					fpfd2List[a].phi = fpfd2List[i].phi;
					fpfd2List[a].eta = fpfd2List[i].eta;
					fpfd2List[a].mass = fpfd2List[i].mass;
					a++;
				}
			}

			fpfd2lstModel.remove(lsti);
			
		}
	}

	private void fpfd2Calculate() {

		if (fpfd2lstModel.getSize() == 0) {
			MsgBox msgbox = new MsgBox("Empty List", "No Data in List");
			return;
		}

		float px, py, pz, higgsenergy, momentum;
		int i;
  
		higgsenergy = 0;
  		px = 0;
		py = 0;
		pz = 0;
		momentum = 0;
 
		for (i=0; i<fpfd2lstModel.getSize(); i++) {
			float pz_temp = fpfd2List[i].energy * (float)((exp(2*fpfd2List[i].eta) - 1) / (exp(2*fpfd2List[i].eta) + 1));
			momentum = (float)sqrt(fpfd2List[i].energy * fpfd2List[i].energy - pz_temp * pz_temp - fpfd2List[i].mass * fpfd2List[i].mass);
			px += (float)(momentum * cos(fpfd2List[i].phi));
			py += (float)(momentum * sin(fpfd2List[i].phi));
			pz += pz_temp;
			higgsenergy += fpfd2List[i].energy;
		}
		fpfd2txtHiggsmass.setText(Float.toString((float)sqrt(higgsenergy * higgsenergy - px * px - py * py - pz * pz)));		
	}

	private void fpfd2Add() {
		
		float checkValue;
		int i = fpfd2lstModel.getSize();
		try {
			checkValue = Float.valueOf(fpfd2txtMass.getText()).floatValue();
			if (checkValue < 0 || checkValue > 500) {
				MsgBox msgbox = new MsgBox("Input Error","<html><body>Mass must be between<br>0Gev/c^2 and 500GeV/c^2</body></html>");
			}
			else {
				fpfd2List[i].energy = Float.valueOf(fpfd2txtEnergy.getText()).floatValue();
				fpfd2List[i].phi = Float.valueOf(fpfd2txtAngle.getText()).floatValue();
				fpfd2List[i].eta = Float.valueOf(fpfd2txtEta.getText()).floatValue();
				fpfd2List[i].mass = checkValue;
				fpfd2lstModel.addElement("E = " + fpfd2txtEnergy.getText() + "; Mass = " + fpfd2txtMass.getText() + "; Phi = " + fpfd2txtAngle.getText() + "; Eta = " + fpfd2txtEta.getText());
				// System.out.println("Phi = " + fpfd2List[i].phi);
				// System.out.println("Eta = " + fpfd2List[i].eta);
				// System.out.println("E   = " + fpfd2List[i].energy);
				// System.out.println("m   = " + fpfd2List[i].mass);
			}
		}
		catch (NumberFormatException e) {MsgBox msgbox = new MsgBox("Empty Field", "Make sure Energy, Angle and mass are given");}
	}

	private void fpfd2Clear() {
		
		fpfd2lstModel.setSize(0);
		fpfd2txtAngle.setText("");
		fpfd2txtEnergy.setText("");
		fpfd2txtMass.setText("");
		fpfd2txtHiggsmass.setText("");
		fpfd2txtEta.setText("");
		
	}
	
	private int stringContains(String source, String check) {

		for (int i=0; i < (source.length() - check.length()); i++) {
			if(source.substring(i, check.length() + i).equals(check)) return i;
		}
		return -1;	

	}

	private boolean decayIsPossible(int pnum, String decay) {

		int i, spos;
		float energyneeded = 0;

		while (true) {
			if ((spos = bubble.stringContains(decay, ",")) > -1) {
				energyneeded += plist[bubble.findParticleName(decay.substring(0,spos))].m;
				decay = decay.substring(spos+1);
			}
			else {
				energyneeded += plist[bubble.findParticleName(decay)].m;
				break;
			}
		}
		if (energyneeded <= (float)sqrt(p[pnum].m * p[pnum].m + p[pnum].p[0] * p[pnum].p[0] + p[pnum].p[1] * p[pnum].p[1])) {
			return true;
		}
		return false;
	
	}
	
	private void showerEcal(int partNum) {
		//System.out.println("Ecal: z = " + p[partNum].x[2]);
		double phi, pvalue;
		double energy, deltaPhi;
		
		energy = sqrt(p[partNum].p[0] * p[partNum].p[0] + p[partNum].p[1] * p[partNum].p[1] + p[partNum].p[2] * p[partNum].p[2] + p[partNum].m * p[partNum].m);
		pvalue = sqrt(p[partNum].x[0] * p[partNum].x[0] + p[partNum].x[1] * p[partNum].x[1] + p[partNum].x[2] * p[partNum].x[2]);
		double theta = acos(p[partNum].x[2] / pvalue);
		// theta += 0.01 * PI * bubble.mcGauss(1);   // 0.5% Smearing on angles
		double eta = -log(tan(theta / 2));
		//System.out.println("Ecal p(z) original = " + p[partNum].p[2]);
		//System.out.println("Ecal p(z) calculated = " + energy * (exp(2*eta) - 1) / (exp(2*eta) + 1));
		
		pvalue = sqrt(p[partNum].p[0] * p[partNum].p[0] + p[partNum].p[1] * p[partNum].p[1]);
		deltaPhi = acos(p[partNum].p[0] / pvalue);
		if(p[partNum].p[1] < 0) deltaPhi = 2 * PI - deltaPhi;
		pvalue = sqrt(p[partNum].x[0] * p[partNum].x[0] + p[partNum].x[1] * p[partNum].x[1]);
		phi = acos(p[partNum].x[0] / pvalue);
		// phi += 0.01 * PI * bubble.mcGauss(1);   // 0.5% Smeering on angles
		if(p[partNum].x[1] < 0) phi = 2 * PI - phi;
		deltaPhi = deltaPhi - phi;
				
		bubble.showerEcalFill(energy, eta, phi);
		frmEcalWindow.updateCalorimeter();
	}

    private double mcGauss(double sigma) {
    	// Guassian function used is f(x) = exp(-x^2/2*sigma^2)
    	Random generator = new Random();
		double range = 5 * sigma;
		double x, value;
		
		if (sigma == 0.0) return 0;
		
		while (true) {
			x = generator.nextDouble() * range;
			value = exp(-x*x/2/sigma*sigma);
			if (value >= generator.nextDouble()) return signum(generator.nextDouble() - 0.5) * x;
		}
    }
	
	private void showerEcalFill(double energy, double eta, double phi) {
		double x, y, sigmax = 0.002, sigmay = 0.002;
		int xpos, ypos;

		if (eta > 3.0 || eta < -3.0) return;

		if(phi > PI) phi -= 2*PI;
		x = eta / 3;
		y = -phi / PI;
		
		// Gauss smearing of Energy
		energy += 0.25 * sqrt(energy) * mcGauss(1);  // really 0.1
		if (energy <= 0.0) return;
		
		double de = energy / 100;
		if (de < 0.01) de = 0.01;
		while (energy > 0) {
			energy -= de;
			if (energy < 0) de = energy + de;
			xpos = (int)(172 * (x + bubble.mcGauss(sigmax))) + 172;
	  		if(x < 0) xpos -= 1;
			ypos = ((int)(180 * (y + bubble.mcGauss(sigmay))) + 180) % 360;
			if (ypos < 0) ypos += 360;
	    	if(y < 0) ypos -= 1;
	    	int arrayPos = (xpos + ypos * 344) % 123840;
	    	if (arrayPos < 0) arrayPos += 123840;
	    	if (xpos >= 0 && xpos < 344) ecal[arrayPos] += de;
		}
	}
	
	private void showerHcal(int partNum) {
		double phi, pvalue;
		double energy, deltaPhi;
		
		energy = sqrt(p[partNum].p[0] * p[partNum].p[0] + p[partNum].p[1] * p[partNum].p[1] + p[partNum].p[2] * p[partNum].p[2] + p[partNum].m * p[partNum].m);
		pvalue = sqrt(p[partNum].x[0] * p[partNum].x[0] + p[partNum].x[1] * p[partNum].x[1] + p[partNum].x[2] * p[partNum].x[2]);
		double theta = acos(p[partNum].x[2] / pvalue);
		// theta += 0.01 * PI * bubble.mcGauss(1);   // 0.5% Smearing on angles
		double eta = -log(tan(theta / 2));
		
		pvalue = sqrt(p[partNum].x[0] * p[partNum].x[0] + p[partNum].x[1] * p[partNum].x[1]);
		phi = acos(p[partNum].x[0] / pvalue);
		// phi += 0.01 * PI * bubble.mcGauss(1);   // 0.5% Smeering on angles
		if(p[partNum].x[1] < 0) phi = 2 * PI - phi;
	
		bubble.showerEcalFill(energy * 0.23, eta, phi);
		bubble.showerHcalFill(energy * 0.77, eta, phi);
		frmHcalWindow.updateCalorimeter();
		frmEcalWindow.updateCalorimeter();
	}
	
	private void showerHcalFill(double energy, double eta, double phi) {
		double x, y, sigmax = 0.008, sigmay = 0.008; //0.008
		int xpos, ypos;

		if (eta > 3.0 || eta < -3.0) return;

		if(phi > PI) phi -= 2*PI;
		x = eta / 3;
		y = -phi / PI;
		
		// Gauss smearing of Energy
		energy += 1.5 * sqrt(energy) * mcGauss(1); // actually is 1.0
		if (energy <= 0.0) return;

		double de = energy / 100;
		if (de < 0.01) de = 0.01;
		while (energy > 0) {
			energy -= de;
			if (energy < 0) de = energy + de;
			xpos = (int)(60 * (x + bubble.mcGauss(sigmax))) + 60;
	  		if(x < 0) xpos -= 1;
			ypos = ((int)(62 * (y + bubble.mcGauss(sigmay))) + 62) % 124;
			if (ypos < 0) ypos += 124;
	    	if(y < 0) ypos -= 1;
	    	int arrayPos = (xpos + ypos * 120) % 14880;
	    	if (arrayPos < 0) arrayPos += 14880;
	    	if (xpos >= 0 && xpos < 120) hcal[arrayPos] += de;
		}
	}

	private void showerEndcaps(int partNum) {
		if (bubble.showersInEcal(partNum)) bubble.showerEcal(partNum);
		if (bubble.showersInHcal(partNum)) bubble.showerHcal(partNum);	
	}

	private boolean showersInEcal(int i) {
		if (p[i].type.equals("e-") || p[i].type.equals("e+") || p[i].type.equals("gamma")) return true;
		return false;
	}
	
	private boolean showersInHcal(int i) {
		if (p[i].type.equals("w-") || p[i].type.equals("w+") || p[i].type.equals("pi-") || p[i].type.equals("pi+") || p[i].type.equals("pi0") || p[i].type.equals("K+") || p[i].type.equals("K-") || p[i].type.equals("K0") || p[i].type.equals("p") || p[i].type.equals("pbar-") || p[i].type.equals("n0") || p[i].type.equals("nbar0") || p[i].type.equals("jet") || p[i].type.equals("pi")) return true;
		return false;
	}

	private boolean checkForCalorimeter(int x, int y, int i) {

		int lblcounter, portion;
		float radius, tempp;
		boolean tempBoolean = false;

		Random random = new Random();

		if (bubble.showersInEcal(i)) {
			radius = (float)sqrt(p[i].x[0] * p[i].x[0] + p[i].x[1] * p[i].x[1]);
			if (radius >= 0.93 && radius < 1) {
				bubble.setGraphics("shower", "", x, y, (float)i, "70.04");
				bubble.showerEcal(i);
				tempBoolean = true;
			}
			else return false;
		}

		if (bubble.showersInHcal(i)) {
			radius = (float)sqrt(p[i].x[0] * p[i].x[0] + p[i].x[1] * p[i].x[1]);
			if (radius >= 0.93 && radius < 1) {
				portion = (int)(random.nextDouble() * 2.99);
				tempp = (float)sqrt(p[i].p[0] * p[i].p[0] + p[i].p[1] * p[i].p[1]);
				bubble.setGraphics("shower", "", x, y, (float)i, Integer.toString(portion) + "0.04");
				bubble.setGraphics("line", "particle", x, y, (float)i, "", (int)(x + 0.07 * runoptions.scaled * p[i].p[0] / tempp), (int)(y - 0.07 * runoptions.scaled * p[i].p[1] / tempp));
				bubble.setGraphics("shower", "", (int)(x + 0.07 * runoptions.scaled * p[i].p[0] / tempp), (int)(y - 0.07 * runoptions.scaled * p[i].p[1] / tempp), (float)i, "70.15", (int)(x + 0.07 * runoptions.scaled * p[i].p[0] / tempp), (int)(y - 0.07 * runoptions.scaled * p[i].p[1] / tempp));
				tempBoolean = true;
				if (!p[i].isbackground) bubble.showerHcal(i);
			}
			else return false;
		}

		tempp = (float)sqrt(p[i].p[0] * p[i].p[0] + p[i].p[1] * p[i].p[1]);
		x = x - (int)(20 * p[i].p[0] / tempp);  		
		y = y + (int)(20 * p[i].p[1] / tempp);  		
		
		if (p[i].x[0] >= 2 || p[i].x[0] <= -2 || p[i].x[1] >= 1.5 || p[i].x[1] <= -1.5) {
			double energy = sqrt(p[i].p[0] * p[i].p[0] + p[i].p[1] * p[i].p[1] + p[i].p[2] * p[i].p[2] + p[i].m * p[i].m);
			double pvalue = sqrt(p[i].x[0] * p[i].x[0] + p[i].x[1] * p[i].x[1] + p[i].x[2] * p[i].x[2]);
			double theta = acos(p[i].x[2] / pvalue);
			// theta += 0.01 * PI * bubble.mcGauss(1);   // 0.5% Smeering on angles
			double eta = -log(tan(theta / 2));
			pvalue = sqrt(p[i].x[0] * p[i].x[0] + p[i].x[1] * p[i].x[1]);
			double phi = acos(p[i].x[0] / pvalue);
			if(p[i].x[1] < 0) phi = 2 * PI - phi;
			// phi += 0.01 * PI * bubble.mcGauss(1);   // 0.5% Smeering on angles
			// Energy Smearing
			energy += 0.1 * sqrt(energy) * mcGauss(1);
			if (energy < 0.0) energy = 0.0;
			lblMuonTag[ctrMuonTag].setTag(x, y, energy, eta, phi);
			lblMuonTag[ctrMuonTag].setVisible(true);
			ctrMuonTag++;
			return true;
		}
		else {
			if (!(tempBoolean)) return false;
		}
 
  		if (!(p[i].isbackground) && ctrEnergyTag < 10) {
  			lblEnergyTag[ctrEnergyTag].setTag(x, y, (float)sqrt(p[i].p[0] * p[i].p[0] + p[i].p[1] * p[i].p[1] + p[i].p[2] * p[i].p[2] + p[i].m * p[i].m));
			lblEnergyTag[ctrEnergyTag].setVisible(true);
			ctrEnergyTag++;
  		}

		return true;
	
	}
	
	private double getHiggsEnergy() {
	
		//  Monte Carlo Energy Selector for Higgs Boson and Black Hole
  
		float lambda, range, yupbound, y;
	
		Random random = new Random();
		
		lambda = (float)0.0012;
		range = 5000;
		yupbound = -1 / lambda * (float)(exp(-lambda * range) - 1);

		y = (float)(random.nextDouble() * yupbound);

		return (log(-lambda * y + 1)) / (-lambda) + 200.0;
	}

	private void createBackground(float energy) {
		
		int pnum;
		int piminus = bubble.findParticleName("pi-");
		int piplus = bubble.findParticleName("pi+");
		
		float tempenergy, px, py, momentum, angle;

		runoptions.isbackground = true;
		while (energy > 0 && pcount < 50) {
			Random random = new Random();
			if (random.nextDouble() <= 0.5) pnum = piplus;
			else pnum = piminus;
			tempenergy = (float)random.nextDouble() * 5 + plist[pnum].m;
			energy = energy - tempenergy;
			momentum = (float)sqrt(tempenergy * tempenergy - plist[pnum].m * plist[pnum].m);
			angle = (float)(random.nextDouble() * 2 * PI);
			px = momentum * (float)cos(angle);
			py = momentum * (float)sin(angle);
			bubble.createParticle(pnum, px, py, 0, 0);
		}
		runoptions.isbackground = false;
	}

	private void changeEvent() {
		
		switch (runoptions.selectedevent) {
			case SINGLEPARTICLE:
				bRerun.setEnabled(false);
				bPpRun.setEnabled(false);
				runoptions.bgimage = "backsingle.jpg";
				pnlSingleParticle.setVisible(true);
				energylosstf.setText("0");
				runoptions.dedx = 0;
				runoptions.b = -2;
				lblHiggsDecay.setText("Single Particle In External Magnetic Field");
				break;
			case HIGGSDECAY:
			case EXTERNALDATA:
			case LAMBDADECAY:
				bRerun.setEnabled(true);
				bPpRun.setEnabled(true);
				pnlSingleParticle.setVisible(false);
				if (runoptions.selectedevent == HIGGSDECAY || runoptions.selectedevent == EXTERNALDATA) {
					runoptions.bgimage = "backcms.jpg";
					runoptions.b = -4;
					lblHiggsDecay.setText("CMS Detector at CERN");  // Higgs Decay
				}
				else {
					runoptions.bgimage = "back.jpg";
					runoptions.b = -2;
					lblHiggsDecay.setText("K- + p --> pi- + Lambda + pi+;   Lambda --> pi- + p");
				}
				energylosstf.setText("0.1");
				runoptions.dedx = (float)0.1;
				pnlSingleParticleMessage.hidePanel();
				break;
		}
		bubble.ppChamberReset();
		spCurrentParticle.setVisible(false);
		runoptions.scaled = 200;
		runoptions.mustrunnew = true;
		bubble.clearAllListAndFields();
		bubble.clearScreen();
		
	}

	private void zoomBackgroundImage() {
		
		int[] temppixs = new int[800*600];
		int xstart, ystart, xpos, ypos, i, j;
		float xcount, ycount, xstep, ystep;

		for(i=0; i<800*600; i++) {temppixs[i] = pixels[i];}
		
		xstart = 400 - (int)((runoptions.x0 + 400) * 200 / runoptions.scaled);
		ystart = 300 - (int)((runoptions.y0 + 300) * 200 / runoptions.scaled);
		ystep = (float)(200 / runoptions.scaled);
		xstep = ystep;
		ycount = ystart;
		
		for (j=0; j<600; j++) {
			xcount = xstart;
			for (i=0; i<800; i++) {
				xpos = (int)xcount;
				ypos = (int)ycount;
				if (xpos > -1 && xpos < 800 && ypos > -1 && ypos < 600) {
					pixels[j * 800 + i] = temppixs[ypos * 800 + xpos];
				}
				else {
					pixels[j * 800 + i] = ((255 << 24) |  (255 << 16) |  (255 << 8 ) | 255);
				}
				xcount = xcount + xstep;
			}
			ycount = ycount + ystep;
		}

	}

	private void loadBackgroundImage() {

		Image image = java.awt.Toolkit.getDefaultToolkit().getImage("pics/" + runoptions.bgimage);
		PixelGrabber grab = new PixelGrabber(image, 0, 0, 800, 600, pixels, 0, 800);
		try {
			grab.grabPixels();
		}
		catch (InterruptedException e) {}	
	}

	private void drawGrid() {
  
  		if (runoptions.showgrid) {
  		
  			int xpos, ypos;
  		
  			for (float h=-(float)1.45; h <= (float)1.5; h+=(float)0.1) {
  				for (float l=-(float)1.95; l <= (float)2; l+=(float)0.1) {
  					xpos = 400 + (int)(runoptions.x0 + runoptions.scaled * l);
  					ypos = 300 + (int)(runoptions.y0 + runoptions.scaled * h);
 					bubble.setPixel(xpos, ypos, 0, 0, 1);
  				}
  			}
  		}
  			
	}

	private boolean checkfortrace(int x, int y) {
  
 		int i;
  		
  		if ((y * 800 + x) < 0 || (y * 800 + x) >= 800*600) return false;
  		
		if (!(pixels[y * 800 + x] == ((255 << 24) |  (255 << 16) |  (255 << 8 ) | 255))) {
			for (i=0; i<=pcount; i++) {
  				if (pixels[y * 800 + x] == ((255 << 24) |  (p[i].farbe.r << 16) |  (p[i].farbe.g << 8 ) | p[i].farbe.b)) {
					pnlFindParticle.moveTo(x-61, y-31);
					pnlFindParticle.setText(p[i].type);
  					return true;
  				}
  			}
  		} 
  		return false;
	}

	private void movefindpart(String art) {
		bubble.movefindpart(art, 0, 0);
	}
	
	private void movefindpart(String art, int x, int y) {
	
		int count = 0, xtemp, ytemp;
		
		if(art.equals("hide")) {}
		else if(art.equals("show")) {}
		else if(art.equals("move")) {
			while (true) {
				if (x - count > 0 && x - count < 801 && y > 0 && y < 601) {
					xtemp = x - count; ytemp = y;
					if (bubble.checkfortrace(xtemp, ytemp)) break;
				}
				if (x + count < 801 && y > 0 && y < 601) {
					xtemp = x + count; ytemp = y;
					if (bubble.checkfortrace(xtemp, ytemp)) break;
				}
				if (y - count > 0 && y - count < 601 && x > 0 && x < 801) {
					ytemp = y - count; xtemp = x;
					if (bubble.checkfortrace(xtemp, ytemp)) break;
				}
				if (y + count < 601 && x > 0 && x < 801) {
					ytemp = y + count; xtemp = x;
					if (bubble.checkfortrace(xtemp, ytemp)) break;
				}
				if (x + count > 800 && x - count < 1 && y + count > 600 && y - count < 1) break;
				count++; 
			}
		}

	}

	private void fpfdtxtRestmassEnter() {

		try {
			if (runoptions.selectedevent == HIGGSDECAY) Float.valueOf(fpfd2txtMass.getText()).floatValue();
			else Float.valueOf(fpfdtxtRestmass.getText()).floatValue();
		}

		catch (NumberFormatException e) {

			int partnum;

			if (runoptions.selectedevent == HIGGSDECAY) partnum = bubble.findParticleName(fpfd2txtMass.getText());
			else partnum = bubble.findParticleName(fpfdtxtRestmass.getText());
			
			if (!(partnum == -1)) {
				if (runoptions.selectedevent == HIGGSDECAY) {
					fpfd2txtMass.setText(Float.toString(plist[partnum].m));
					comMomenta2.setSelectedIndex(partnum);
				}
				else {
					fpfdtxtRestmass.setText(Float.toString(plist[partnum].m));
					comMomenta.setSelectedIndex(partnum);
				}
			}	
			else {
				if (runoptions.selectedevent == HIGGSDECAY) fpfd2txtMass.setText("Part. not Found");
				else fpfdtxtRestmass.setText("Part. not Found");
			}
		}
	}

	private void fpfdCalculate() {
		
		if (fpfdlstModel.getSize() == 0) {
			MsgBox msgbox = new MsgBox("Empty List", "No Data in List");
			return;
		}

		float energy, momentumx, momentumy, timeconstant, invariantmass;
		
		energy = 0; momentumx = 0; momentumy = 0;
		
		for (int i=0; i<fpfdlstModel.getSize(); i++) {
			energy = energy + (float)sqrt(fpfdList[i].momentumX * fpfdList[i].momentumX + fpfdList[i].momentumY * fpfdList[i].momentumY + fpfdList[i].mass * fpfdList[i].mass);
			momentumx = momentumx + fpfdList[i].momentumX;
			momentumy = momentumy + fpfdList[i].momentumY;
		}
		invariantmass = (float)sqrt(energy * energy - momentumx * momentumx - momentumy * momentumy);
		fpfdtxtRestmassAnswer.setText(Float.toString(invariantmass)); 
		
		try {
			timeconstant = Float.valueOf(fpfdtxtDistanceTraveled.getText()).floatValue() * invariantmass / (float)(sqrt(momentumx * momentumx + momentumy * momentumy) * 0.3);
			fpfdtxtLifetime.setText(Float.toString(timeconstant));
		}
		catch(NumberFormatException e) {};
	}

	private void fpfdRemove() {
	
		int lsti = fpfdlstParticles.getSelectedIndex();
		if (lsti > -1) {

			int a = 0;
			
			for (int i=0; i<fpfdlstModel.getSize();i++) {
				if (!(i == lsti)) {
					fpfdList[a].momentumX = fpfdList[i].momentumX;
					fpfdList[a].momentumY = fpfdList[i].momentumY;
					fpfdList[a].mass = fpfdList[i].mass;
					a++;
				}
			}

			fpfdlstModel.remove(lsti);
			
		}
	}
	
	private void fpfdClear() {
		
		fpfdlstModel.setSize(0);
		fpfdtxtMomentumx.setText("");
		fpfdtxtMomentumy.setText("");
		fpfdtxtRestmass.setText("");
		fpfdtxtDistanceTraveled.setText("");
		fpfdtxtRadius.setText("");
		fpfdtxtRestmassAnswer.setText("");
		fpfdtxtLifetime.setText("");
		
	}
	
	private void fpfdAdd() {

		float checkValue;
		int i = fpfdlstModel.getSize();
		try {
			checkValue = Float.valueOf(fpfdtxtRestmass.getText()).floatValue();
			if (checkValue < 0 || checkValue > 500) {
				MsgBox msgbox = new MsgBox("Input Error","<html><body>Mass must be between<br>0Gev/c^2 and 500GeV/c^2</body></html>");
			}
			else {
				fpfdList[i].mass = checkValue;
				fpfdList[i].momentumX = Float.valueOf(fpfdtxtMomentumx.getText()).floatValue();
				fpfdList[i].momentumY = Float.valueOf(fpfdtxtMomentumy.getText()).floatValue();
				fpfdlstModel.addElement("P(x) = " + fpfdtxtMomentumx.getText() + "; P(y) = " + fpfdtxtMomentumy.getText() + "; Mass = " + fpfdtxtRestmass.getText());
			}
		}
		catch (NumberFormatException e) {MsgBox msgbox = new MsgBox("Empty Field", "Make sure momentum and mass are given");}
	}

	private void doFit() {

		double a,b,c,d,x,y,x2,y2,maxmomentum,pvalue;
		int i,n, direction;
		float momentum;

		if (circlefit.x[0] - circlefit.x[1] == 0) circlefit.x[0] = circlefit.x[0] + (float)0.1;
		if (circlefit.x[1] - circlefit.x[2] == 0) circlefit.x[1] = circlefit.x[1] + (float)0.1;
		a = (pow(circlefit.x[0],2.) - pow(circlefit.x[1],2.) + pow(circlefit.y[0],2.) - pow(circlefit.y[1],2.)) / (2 * (circlefit.x[0] - circlefit.x[1]));
		b = (circlefit.y[0] - circlefit.y[1]) / (circlefit.x[0] - circlefit.x[1]);
		c = (pow(circlefit.x[1],2.) - pow(circlefit.x[2],2.) + pow(circlefit.y[1],2.) - pow(circlefit.y[2],2.)) / (2 * (circlefit.x[1] - circlefit.x[2]));
 		d = (circlefit.y[1] - circlefit.y[2]) / (circlefit.x[1] - circlefit.x[2]);

		circlefit.o[1] = (float)((a - c) / (b - d));
		circlefit.o[0] = (float)(c - d * circlefit.o[1]);
		circlefit.r = (float)sqrt(pow(circlefit.x[0] - circlefit.o[0],2.) + pow(circlefit.y[0] - circlefit.o[1],2.));
 
 		pvalue = abs(runoptions.b) * circlefit.r / runoptions.scaled * 0.3;
		if (Double.isNaN(pvalue)) {MsgBox msgbox = new MsgBox("Error","Points are not on a circle"); return;}
  
		bubble.setGraphics("cross", "blue", (int)circlefit.o[0], (int)circlefit.o[1], 0, "");
		bubble.setGraphics("circle", "red", (int)circlefit.o[0], (int)circlefit.o[1], circlefit.r, "mix");
  
		a = (circlefit.y[0] - circlefit.o[1]) / (circlefit.x[0] - circlefit.o[0]);
		circlefit.p[1] = (float)(pvalue / sqrt(1 + a * a));
		circlefit.p[0] = circlefit.p[1] * (float)a;
 
		x = circlefit.x[1] - circlefit.x[0];
 		y = circlefit.y[1] - circlefit.y[0];
		x2 = circlefit.x[2] - circlefit.x[0];
		y2 = circlefit.y[2] - circlefit.y[0];

		direction = (int)signum((int)(x * y2 - x2 * y));

		x2 = circlefit.p[0];
		y2 = -circlefit.p[1];
 
		if (direction != (int)signum((int)(x2 * y - x * y2))) {circlefit.p[0] = -circlefit.p[0]; circlefit.p[1] = -circlefit.p[1];}

		maxmomentum = sqrt(pow(Float.valueOf(initialmomentumxtf.getText()).floatValue(),2.) + pow(Float.valueOf(initialmomentumytf.getText()).floatValue(),2.));
		bubble.setGraphics("arrow", "blue", (int)circlefit.x[0], (int)circlefit.y[0], 0, "", (int)(circlefit.x[0] + circlefit.p[0] / maxmomentum * 200), (int)(circlefit.y[0] - circlefit.p[1] / maxmomentum * 200));

		momentum = (float)pvalue;
		
		fpfdtxtMomentumx.setText(Float.toString(circlefit.p[0]));
		fpfdtxtMomentumy.setText(Float.toString(circlefit.p[1]));
		fpfdtxtRadius.setText(Float.toString(circlefit.r / runoptions.scaled));
		pnlSingleParticle.setRadius(circlefit.r / runoptions.scaled);
		pnlSingleParticle.setMeasuredP(momentum);
		pnlSingleParticle.setError(abs((momentum - pnlSingleParticle.getP()) * 100 / pnlSingleParticle.getP()));
		if (!(runoptions.selectedevent == SINGLEPARTICLE || runoptions.selectedevent == LAMBDADECAY)) {
			MsgBox msgbox = new MsgBox("Circle Fit", "<html>P(x) = " + Float.toString(circlefit.p[0]) + " GeV / c^2<br>P(y) = " + Float.toString(circlefit.p[1]) + " GeV / c^2<br>Radius = " + Float.toString(circlefit.r / runoptions.scaled) + " m</html>");
		}
	
		if (pnlSingleParticleMessage.isDisplayed()) pnlSingleParticleMessage.nextMessage();
	}

	private void setPixel(int x, int y, int r, int g, int b) {
		bubble.setPixel(x, y, r, g, b, "");
	}

	private void setPixel(int x, int y, int r, int g, int b, String mix) {
	
		if (x>-1 && x<800 && y>-1 && y< 600) {
			if(mix.equals("mix")) {
				pixels[y * 800 + x] = (128 << 24) |  (r << 16) |  (g << 8 ) | b;
			}
			else {
				pixels[y * 800 + x] = (255 << 24) |  (r << 16) |  (g << 8 ) | b;
			}
		}

	}

	private void setGraphics(String art, String color, int x, int y, float msing, String mstrg) {
		bubble.setGraphics(art, color, x, y, msing, mstrg, 0, 0);
	}

	private void setGraphics(String art, String color, int x, int y, float msing, String mstr, int x2, int y2) {
		
		int i, xpos, ypos, cr=0, cg=0, cb=0, j;
		float a, stepping, y3, x3, h, l, offsetx, offsety, temp, temp2;
		double x4;
	
		try {Float.valueOf(color).floatValue();}
		catch (NumberFormatException e) {
			if (color.equals("red")) {cr = 254; cg = 0; cb = 0;}
			if (color.equals("blue")) {cr = 0; cg = 0; cb = 254;}
			if (color.equals("gray")) {cr = 128; cg = 128; cb = 128;}
			if (color.equals("yellow")) {cr = 255; cg = 254; cb = 0;}
			if (color.equals("darkgray")) {cr = 64; cg = 64; cb = 64;}
			if (color.equals("lightgray")) {cr = 192; cg = 192; cb = 192;}
			if (color.equals("black")) {cr = 0; cg = 0; cb = 0;}
			if (color.equals("particle")) {i = (int)msing; cr = p[i].farbe.r; cg = p[i].farbe.g; cb = p[i].farbe.b;}
		}

		if (art.equals("cross")) {
			for (i=-3; i<4; i++) {
				bubble.setPixel(x + i, y + i, cr, cg, cb);
				bubble.setPixel(x + i, y - i, cr, cg, cb);
			}
		}
		if (art.equals("circle")) {
			stepping = (float)(1 / (msing * 2 * PI));
			for (a=0; a<=1; a+=stepping) {
				bubble.setPixel(x + (int)(msing * (float)cos(2 * PI * a)), y + (int)(msing * (float)sin(2 * PI * a)), cr, cg, cb, mstr);
			}
		}
		if (art.equals("line")) {
			stepping = (float)(1/sqrt(pow(x - x2, 2.) + pow(y - y2, 2.)));
			for (a=0; a<=1; a+=stepping) {
				bubble.setPixel((int)(x + (x2 - x) * a), (int)(y + (y2 - y) * a), cr, cg, cb);
			}
		}
		if (art.equals("arrow")) {
			bubble.setGraphics("line", color, x, y, msing, mstr, x2, y2);
			x3 = (x - x2) / (float)sqrt(pow(x - x2, 2.) + pow(y - y2, 2.)) * 6;
			y3 = (y - y2) / (float)sqrt(pow(x - x2, 2.) + pow(y - y2, 2.)) * 6;
			bubble.setGraphics("line", color, (int)(x2 + x3 + y3 / 2), (int)(y2 + y3 - x3 / 2), msing, mstr, x2, y2);
			bubble.setGraphics("line", color, (int)(x2 + x3 - y3 / 2), (int)(y2 + y3 + x3 / 2), msing, mstr, x2, y2);
		}
		if (art.equals("bigcross")) {
			bubble.setGraphics("line", color, x - 3, y - 3, msing, "norefresh", x + 4, y + 4);
			bubble.setGraphics("line", color, x - 3, y + 4, msing, "norefresh", x + 4, y - 3);
		}		
		if (art.equals("drawbfield")) {
			for (h=(float)-0.6; h<=(float)0.7; h+=(float)0.2) {
				for (l=(float)-1.1; l<=(float)1.2; l+=(float)0.2) {
					xpos = (int)(400 + runoptions.x0 + l * runoptions.scaled);
					ypos = (int)(300 + runoptions.y0 - h * runoptions.scaled);
					if (runoptions.b>0) {
						bubble.setGraphics("circle", "black", xpos + 1, ypos + 1, 2, "norefresh");
					}
					else {
						bubble.setGraphics("bigcross", "black", xpos, ypos, 0, "norefresh");
					}					
				}
			}
		}
		if (art.equals("shower")) {
			i = Integer.valueOf(mstr.substring(0,1)).intValue();
			h = Float.valueOf(mstr.substring(1,mstr.length())).floatValue();
			if (p[(int)msing].p[0] == 0) {
				if (p[(int)msing].p[1] > 0) a = PI / 2;
				else a = PI / 2 * 3;
			}
			else {
				a = (float)(atan(p[(int)msing].p[1] / p[(int)msing].p[0]) - (signum(p[(int)msing].p[0]) - 1) * PI / 2);
			}
			h = h * runoptions.scaled;
			Random random = new Random();
			for (l=0; l <= i * h / runoptions.scaled / 0.01; l++) {
				temp = (float)random.nextDouble() * h;
				offsetx = temp * (float)cos(a);
				offsety = temp * (float)sin(a);
				temp = (float)random.nextDouble() * h / 5;
				temp2 = (float)signum(random.nextDouble() - 0.5);
				offsetx = offsetx - temp2 * temp * (float)sin(a);
				offsety = offsety + temp2 * temp * (float)cos(a);
				for (x4=-0.003; x4<=0.003; x4 = x4 + (1. / 2. / runoptions.scaled)) {
					bubble.setGraphics("line", "particle", (int)(x + offsetx - (float)(sin(a) * x4) * runoptions.scaled), (int)(y - offsety - (float)(cos(a) * x4) * runoptions.scaled), msing, "norefresh", (int)(x + offsetx + 0.01 * runoptions.scaled * (float)cos(a) - (float)(sin(a) * x4) * runoptions.scaled), (int)(y - offsety - 0.01 * runoptions.scaled * (float)sin(a) - (float)(cos(a) * x4) * runoptions.scaled));
				}
				x4 = 0.003;
				bubble.setGraphics("line", "particle", (int)(x + offsetx - (float)(sin(a) * x4) * runoptions.scaled), (int)(y - offsety - (float)(cos(a) * x4) * runoptions.scaled), msing, "norefresh", (int)(x + offsetx + 0.01 * runoptions.scaled * (float)cos(a) - (float)(sin(a) * x4) * runoptions.scaled), (int)(y - offsety - 0.01 * runoptions.scaled * (float)sin(a) - (float)(cos(a) * x4) * runoptions.scaled));
			}
		}
		if (!mstr.equals("norefresh")) canvas.repaint();	
	}

	private void turnOffMouse() {
		mouse.counter = 0;
		mouse.zoomclick = 0;
		pnlFindParticle.setVisible(false);
	}

	private void ppRun() {
		float checkValue, checkValue2, pvalue;
		boolean inputOk = true;
		
		checkValue = Float.valueOf(initialpositionxtf.getText()).floatValue();
		if (checkValue < -2.0 || checkValue > 2.0) {
			MsgBox msgbox = new MsgBox("Input Error","<html><body>Initial Position(x) must be<br>between -2.0m and 2.0m</body></html>");
			inputOk = false;
		}
		else runoptions.inposx = checkValue;
		checkValue = Float.valueOf(initialpositionytf.getText()).floatValue();
		if (checkValue < -1.5 || checkValue > 1.5) {
			MsgBox msgbox = new MsgBox("Input Error","<html><body>Initial Position(y) must be<br>between -1.5m and 1.5m</body></html>");
			inputOk = false;
		}
		else runoptions.inposy = checkValue;
		checkValue = Float.valueOf(initialmomentumxtf.getText()).floatValue();
		checkValue2 = Float.valueOf(initialmomentumytf.getText()).floatValue();
		pvalue = (float)sqrt(checkValue * checkValue + checkValue2 * checkValue2);
		if (pvalue < 0.001 || pvalue > 1000) {
			MsgBox msgbox = new MsgBox("Input Error","<html><body>Total Momentum must be<br>between 0.001GeV/c and 1000GeV/c</body></html>");
			inputOk = false;
		}
		else {
			runoptions.inmomx = checkValue;
			runoptions.inmomy = checkValue2;
		}
		if (inputOk) bubble.newRun();
		else bubble.ppReset();
	}

	private void ppApply() {
		float checkValue;
		
		checkValue = Float.valueOf(magneticfieldtf.getText()).floatValue();
		if (checkValue < -1000 || checkValue > 1000) {
			MsgBox msgbox = new MsgBox("Input Error", "<html><body>Magnetic Field must be bewtween<br>-1000T and 1000T</body></html>");
		}
		else runoptions.b = checkValue;
		checkValue = Float.valueOf(distancesteppingtf.getText()).floatValue();
		if (checkValue < 0.000001 || checkValue > 0.03) {
			MsgBox msgbox = new MsgBox("Input Error", "<html><body>Distance Stepping must be bewtween<br>1.0E-5m and 0.03m</body></html>");
		}
		else runoptions.dl = checkValue;
		checkValue = Float.valueOf(energylosstf.getText()).floatValue();
		if (checkValue < 0 || checkValue > 10) {
			MsgBox msgbox = new MsgBox("Input Error", "<html><body>Energy Loss must be bewtween<br>0MeV/m and 10MeV/m</body></html>");
		}
		else runoptions.dedx = checkValue;
		runoptions.mustrunnew = true;
		if (runoptions.selectedevent == SINGLEPARTICLE) bubble.clearScreen();
		bubble.ppChamberReset();
	}

	private void ppChamberReset() {
		magneticfieldtf.setText(Float.toString(runoptions.b));
		distancesteppingtf.setText(Float.toString(runoptions.dl));
		energylosstf.setText(Float.toString(runoptions.dedx));
	}

	private void ppReset() {
		initialpositionxtf.setText(Float.toString(runoptions.inposx));
		initialpositionytf.setText(Float.toString(runoptions.inposy));
		initialmomentumxtf.setText(Float.toString(runoptions.inmomx));
		initialmomentumytf.setText(Float.toString(runoptions.inmomy));
	}

	private String makeString(int num, int Length) {
		
  		String s = new String();
  		int i;
  		
  		s = Integer.toString(num);
  		s = s.trim();
  		if (s.length() < Length) {
  			while (s.length() < Length) {s = "0" + s;}
  		}
  		return s;  
	}
	
	private void loadColors() {

		int myByte;
		RandomAccessFile input = null;
		int i=0, zufall, farbe;
		String s = new String();
		String alts = new String();
		boolean flag;
		
		s = "";
		for (i=1; i<216;i++) {
			s = s + bubble.makeString(i,3);
		}

		// Shuffle the colors
		Random generator = new Random();
		alts = "";
		while(s.length() > 3) {
			zufall = (int)(generator.nextDouble()*(s.length() / 3 - 1) + 0.5);
			alts = alts + s.substring(zufall * 3, zufall * 3 + 3);
			if (zufall>0 && zufall< (s.length() / 3 - 1)) {
				s = s.substring(0, zufall*3) + s.substring(zufall*3+3, s.length());
			}
			else if (zufall == 0) s = s.substring(3,s.length());
			else s = s.substring(0, s.length()-3);
		}
		alts = alts + s;
		
		try {
			
			input = new RandomAccessFile("color.tbl","r");

			for (i=0; i<215; i++) {
				farbe = Integer.parseInt(alts.substring(i*3,i*3+3)) - 1;
				myByte = (int)(input.readByte() & 0xFF);
				colortable[farbe].r = myByte;
				myByte = (int)(input.readByte() & 0xFF);
				colortable[farbe].g = myByte;
				myByte = (int)(input.readByte() & 0xFF);
				colortable[farbe].b = myByte;
			}
		}

		catch (FileNotFoundException ex) {
			ex.printStackTrace();
		}
		catch (IOException ex){
			ex.printStackTrace();
		}

		finally {
			try {
				input.close();
	        }

			catch (IOException ex) {
				ex.printStackTrace();
 			}
		}
		
		for (i=0; i<=pcount; i++) {
			flag = false;
			if (runoptions.selectedevent == HIGGSDECAY) {
				if (p[i].farbe.r == 192 && p[i].farbe.g == 192 && p[i].farbe.b == 193) flag = true;
			}
			if(!flag) {
				p[i].farbe.r = colortable[i].r;
				p[i].farbe.g = colortable[i].g;
				p[i].farbe.b = colortable[i].b;
			}
			bubble.assignSpecificColorsToParticles(i);
		}
	}


	private void newRun() {

		if(!runScreenThread && !runOrbitThread) {

			if (!bubble.runParticle(1)) return;
			
			bubble.clearAllListAndFields();
			// if(runoptions.selectedevent == HIGGSDECAY) lblHiggsDecay.setText("");
			if(!frmParticleLegend.isVisible()) {
				frmParticleLegend.setLocation(frame.getX() + frame.getWidth(), frame.getY());
				frmParticleLegend.setVisible(true);
			}
			if(pnlSingleParticleMessage.isDisplayed()) pnlSingleParticleMessage.nextMessage();
		
			runScreenThread = true;
			RefreshScreenClass refreshScreen = new RefreshScreenClass();
			refreshScreen.start();

			runOrbitThread = true;
			Orbit orbit = new Orbit();
			orbit.start();
		}
	}
	
	private void rerun() {
		
		if(!runScreenThread && !runOrbitThread) {

			if (!bubble.runParticle(0)) return;
			bubble.fillParticleLegend();
		
			runScreenThread = true;
			RefreshScreenClass refreshScreen = new RefreshScreenClass();
			refreshScreen.start();

			runOrbitThread = true;
			Orbit orbit = new Orbit();
			orbit.start();
		}
	}
	
	private void Stop() {
		runOrbitThread = false;
		runScreenThread = false;
	}
	
	// findParticleName method: given a string, find the number that correlated to the particle.
	public int findParticleName(String partlistname) {
		int o = 0;
		int a = -1;

		while (o < lengthOfParticleList) {
			if (partlistname.equals(plist[o].name)) {
				a = o;
//				System.out.println("Particle Found " + partlistname);
				return a;
			}
			o++;
		}
//		System.out.println("Cannot find particle " + partlistname);
		return a;
	}


		// decayParticle method: decays the particle
		public void decayParticle(int i) {
		
//			System.out.println(p[i].type + " -> " + p[i].decaysinto); 

			int o = 0;
			int r = 0;

			if (p[i].collideswith.length() != 0) {
				int u = findParticleName(p[i].collideswith);
				p[i].m = p[i].m + plist[u].m;
			}
			
			int []pnums = new int [10];
			String s = new String();
			int pnumsc = 0;
			double restmass;
			p[i].isactive = false;		
			s = p[i].decaysinto;

			
			while (true) {
				for (o = 0; o < s.length(); o++) {
					if (s.charAt(o) == ',') {
						String sub = s.substring(0,o);
						pnums[pnumsc] = findParticleName(sub);
						pnumsc++;
						s = s.substring(o+1);
						break;
					}
				}
				if (o == s.length()) {
					pnums[pnumsc] = findParticleName(s);
					break;
				}
			}
			
			if (p[i].isbackground) runoptions.isbackground = true;
			
			if (pnumsc == 1) split(i, pnums[0], pnums[1]);
			else {
				restmass = 0;
				for (o = 0; o <= pnumsc; ++o) {
					restmass += plist[pnums[o]].m;
				}
				float massSteps = (float)((p[i].m - restmass) / (pnumsc + 1));
				float tempMass = 0;
				for (o = 0; o <= pnumsc; ++o) {
					if(!(o + 1 == pnumsc)) {
						tempMass = p[i].m - massSteps - plist[pnums[o]].m;
						split(i, pnums[o], -tempMass);
					}
					else {
						split(i, pnums[o], pnums[o + 1]);
						break;
					}
				} 
			}
/*			for (o = 0; o <= pnumsc; o++) {
				if (o+1 < pnumsc) {
					restmass = 0;
					for (r = o+1; r <= pnumsc; r++) {
						restmass = restmass + plist[pnums[r]].m;
					}
					
					split(i, pnums[o], -restmass);
				}
				else {
					restmass = pnums[o+1];
					split(i, pnums[o], pnums[o+1]);
					break;
				}
			} */
			runoptions.isbackground = false;
		} // close decayParticle


		// split method: governs the splitting off the particles
		public void split(int pnum, int pone, double ptwo) {
			
			double wa, wb, wc;
			double ea, eb, ec;
			double gamma, beta, betx, bety, betz;
			double energy, cs, sn;
			double phi;
			double []b = new double [5];
			double alen, phip, phxpri, phypri, phzpri, tht;
			double betap, c1, pb;
			double []c = new double [5];
			
			wa = p[pnum].m;
			wb = plist[pone].m;
			
			if (ptwo < 0) {
				wc = abs(ptwo);
			}
			else {
				wc = plist[(int)ptwo].m;
			}
			
			ea = wa;
			eb = (0.5 / wa) * (pow(wa,2.) + pow(wb,2.) - pow(wc,2.));
			ec = (0.5 / wa) * (pow(wa,2.) + pow(wc,2.) - pow(wb,2.));
			
			energy = sqrt(pow(p[pnum].m,2.) + pow(p[pnum].p[0],2.) + pow(p[pnum].p[1],2.));
			gamma = energy / wa;
			beta = sqrt(pow(p[pnum].p[0],2.) + pow(p[pnum].p[1],2.)) / energy;
			betx = p[pnum].p[0] / energy;
			bety = p[pnum].p[1] / energy;
			betz = p[pnum].p[2] / energy;
			
			Random generator = new Random();
			
			cs = 1 - 2 * generator.nextDouble();
			sn = abs(sqrt(1 - pow(cs,2.)));
			if(cs <= 0) sn = -abs(sn);  // x-y plane means sn = 1; cs = 0
			if(cs > 0 ) sn = abs(sn);
			if(runoptions.selectedevent == LAMBDADECAY) {
			  sn = 1; cs = 0; // to force planar decay
			}
			phi = 3.1415927 * 2 * generator.nextDouble();
			pb = sqrt(pow(eb,2.) - pow(wb,2.));		
			b[4] = eb;
			b[3] = pb * cs;
			b[2] = pb * sn * sin(phi);
			b[1] = pb * sn * cos(phi);
			alen = sqrt(pow(p[pnum].p[0],2.) + pow(p[pnum].p[1],2.) + pow(p[pnum].p[2],2.));
			tht = acos(p[pnum].p[2]/alen);
			tht = 0;  // to force planar decay
			
			if (p[pnum].p[0] != 0) {
				phip = atan(p[pnum].p[1] / p[pnum].p[0]);
			}
			else {
				if (p[pnum].p[1] > 0) {
					phip = 3.1415927 / 2;
				}
				else {
					phip = 3.1415927 * 1.5;
				}
			}
			
			if (p[pnum].p[0] < 0) {
				phip = phip + 3.1415927;
			}
			
			if (p[pnum].p[0] >= 0 && p[pnum].p[1] < 0) {
				phip = 2 * 3.1415927 + phip;
			}
			
			// phxpri = b[1];  // this is another rotation?
			// phypri = b[2];  // not included in older two body routines
			// phzpri = b[3];  // what is its purpose?
			// b[1] = cos(phip)*(cos(tht)*phxpri+sin(tht)*phzpri) - sin(phip)*phypri;
			// b[2] = sin(phip)*(cos(tht)*phxpri+sin(tht)*phzpri) + cos(phip)*phypri;
			// b[3] = -sin(tht)*phxpri + cos(tht)*phzpri;

			// b[1] = cos(phip) * phxpri - sin(phip) * phypri;
			// b[2] = sin(phip) * phxpri + cos(phip) * phypri;
			betap = betx * b[1] + bety * b[2] + betz * b[3];
			c1 = ((betap * (gamma - 1)) / pow(beta,2.)) + gamma * eb;
			b[4] = gamma * (eb + betap);
			b[3] = b[3] + c1 * betz;
			b[2] = b[2] + c1 * bety;
			b[1] = b[1] + c1 * betx;
			c[4] = energy - b[4];
			c[3] = p[pnum].p[2] - b[3];
			c[2] = p[pnum].p[1] - b[2];
			c[1] = p[pnum].p[0] - b[1];

	        // System.out.println("p(x) = " + b[1]);
	        // System.out.println("p(y) = " + b[2]);
	        // System.out.println("p(z) = " + b[3]);
	
			bubble.createParticle(pone, (float)b[1], (float)b[2], (float)b[3], p[pnum].x[0], p[pnum].x[1], p[pnum].x[2]);		
			if (ptwo >= 0) {
				bubble.createParticle((int)ptwo, (float)c[1], (float)c[2], (float)c[3], p[pnum].x[0], p[pnum].x[1], p[pnum].x[2]);
			}
			else {
				p[pnum].p[0] = (float)c[1];
				p[pnum].p[1] = (float)c[2];
				p[pnum].p[2] = (float)c[3];
				p[pnum].m = -(float)ptwo;
			}
		} // close split	


		// createParticle method: creates the particles spun off from the split.
		public void createParticle(int pnum, float momx, float momy, float x, float y) {
			bubble.createParticle(pnum, momx, momy, (float)0, x, y, (float)0);
		}
		
		public void createParticle(int pnum, float momx, float momy, float momz, float x, float y, float z) {
		
			double prob;
			String s = new String();
			double gamma, energy;
			String a = new String();
			double momentum, angle;
			int o;
			double prob2 = 0;
			
			Random generator = new Random();
			
			pcount = pcount + 1;
			p[pcount].type = plist[pnum].name;
			p[pcount].isactive = true;
			p[pcount].q = plist[pnum].q;
			p[pcount].m = plist[pnum].m;
			p[pcount].makespath = plist[pnum].makespath;
			if (p[pcount].type.equals("Higgs")) {
				energy = bubble.getHiggsEnergy();
				momentum = sqrt(energy * energy - p[pcount].m * p[pcount].m);
				angle = generator.nextDouble() * 2 * PI;
				p[pcount].p[0] = (float)(momentum * cos(angle));
				p[pcount].p[1] = (float)(momentum * sin(angle));
				p[pcount].p[2] = (float)0;
			}
			else if (p[pcount].type.equals("bh")) {
				p[pcount].m += (float)bubble.getBlackHoleMassAddition();
				p[pcount].p[0] = (float)0.01;
				p[pcount].p[1] = (float)0.01;
				p[pcount].p[2] = (float)0.01;
			}
			else {
				p[pcount].p[0] = momx;
				p[pcount].p[1] = momy;
				p[pcount].p[2] = momz;
			}
			p[pcount].x[0] = x;
			p[pcount].x[1] = y;
			p[pcount].x[2] = z;
			p[pcount].dtraveled = 0;
			p[pcount].repp[0] = p[pcount].p[0]; //momx
			p[pcount].repp[1] = p[pcount].p[1];
			p[pcount].repp[2] = p[pcount].p[2];
			p[pcount].repx[0] = x;
			p[pcount].repx[1] = y;
			p[pcount].repx[2] = z;
			p[pcount].collideswith = "";
			
			if (!runoptions.isbackground) {
				p[pcount].farbe.r = colortable[pcount % 213].r;
				p[pcount].farbe.g = colortable[pcount % 213].g;
				p[pcount].farbe.b = colortable[pcount % 213].b;
				bubble.assignSpecificColorsToParticles(pcount);
			}
			else {
 				p[pcount].farbe.r = 192;
 				p[pcount].farbe.g = 192;
 				p[pcount].farbe.b = 193;
			}
			p[pcount].isbackground = runoptions.isbackground;
			if (p[pcount].makespath) s = "   --------   ";
			else s = "                 ";
			if (!(runoptions.isbackground)) pnlParticleLegend.addParticle(s + p[pcount].type + " (m = " + Float.toString(p[pcount].m) + ")", p[pcount].farbe.r, p[pcount].farbe.g ,p[pcount].farbe.b);

			// double tempEnergy = sqrt(p[pcount].m * p[pcount].m + p[pcount].p[0] * p[pcount].p[0] + p[pcount].p[1] * p[pcount].p[1] + p[pcount].p[2] * p[pcount].p[2]);
			// System.out.println("Particle Mass = " + p[pcount].m + "  Particle Energy = " + tempEnergy);
		
			while (true) {
				prob = generator.nextDouble() * 100;
				s = plist[pnum].candecayinto;
				if (s.equals("")) {
					p[pcount].decaysinto = "";
					p[pcount].decaylength = -1;
					return;
				}
				
				while (true) {
					for (o = 0; o < s.length(); o++) {
						if (s.charAt(o) == ';') {
							a = s.substring(0,o);
							s = s.substring(o+1);
							break;
						}
					}
					if (o == s.length()) {
						prob = 0;
						a = s;
					}
					for (o = 0; o < s.length(); o++) {
						if (s.charAt(o) == ',') {
							prob2 = Double.valueOf(a.substring(0,o)).doubleValue();
							a = a.substring(o+1);
							break;		
						}
					}
					if (prob2 >= prob) {
						p[pcount].decaysinto = a;
						break;
					}
					prob = prob - prob2;
				}
				if (bubble.decayIsPossible(pcount, p[pcount].decaysinto)) break;
			}
			energy = sqrt(pow(p[pcount].m,2.) + pow(momx,2.) + pow(momy,2.) + pow(momz,2.));
			gamma = energy / p[pcount].m;
			p[pcount].decaylength = (float)(-gamma * plist[pnum].decaylength * log(-1. * generator.nextDouble() + 1.));
			
			// if (runoptions.selectedevent == HIGGSDECAY) lblHiggsDecay.setText(lblHiggsDecay.getText() + p[pcount].type + " --> " + p[pcount].decaysinto + ";   ");
			
		} // close createParticle


		// runParticle method
		public boolean runParticle (int type) {
		
			switch (type) {
				case 0:			// 0 is Rerun
								if (!runoptions.mustrunnew) {
									bubble.clearScreen();
									runoptions.replay = true;
									pnlParticleLegend.clearPanel();
									return true;
								}
								else {
									MsgBox msgBox = new MsgBox("Alert", "New Run Requried!");
									return false;
								}
				case 1:			// 1 is New Run
								runoptions.mustrunnew = false;
								runoptions.scaled = 200;
								runoptions.replay = false;
								runoptions.x0 = 0;
								runoptions.y0 = 0;
								bubble.clearScreen();
								pnlParticleLegend.clearPanel();
								return true;
			}
			return true;
		} // close runParticle

		public void checkForActiveParticles() {
			int i, x, y;
			
			if (runoptions.selectedevent == SINGLEPARTICLE) { 
				x = (int)(-1 * signum(runoptions.b* plist[pnlSingleParticle.getListIndex()].q) * runoptions.scaled + runoptions.x0 + 400);
				y = (int)(1.4 * runoptions.scaled + runoptions.y0 + 300);
				bubble.setGraphics("arrow","blue",x,y,0,"",x,y - 40);
				Insets insets = canvas.getInsets();
				spCurrentParticle.setText(pnlSingleParticle.getListItem(pnlSingleParticle.getListIndex()));
				spCurrentParticle.setBounds(x + 10 + insets.left, y - 10 + insets.top,100,16);
				spCurrentParticle.setVisible(true);
			}
			
			for (i=0; i<=pcount; i++) {
				if(p[i].isactive) break;
				if(i==pcount) {runOrbitThread=false; runScreenThread=false;}
			}
			
		}


		// clearScreen method
		public void clearScreen () {
		
			int i;
			for (i = 0; i < 800 * 600; i++) {
					pixels[i] = (255 << 24) |  (255 << 16) |  (255 << 8 ) | 255;
					canvas.repaint();
			}
			bubble.loadBackgroundImage();
			if (ctrEnergyTag > 0) {
				for (i=0; i<ctrEnergyTag; i++) {
					lblEnergyTag[i].setVisible(false);
				}
				ctrEnergyTag = 0;
			}
			if (ctrMuonTag > 0) {
				for (i=0; i<ctrMuonTag; i++) {
					lblMuonTag[i].setVisible(false);
				}
				ctrMuonTag = 0;
			}
			if (runoptions.zoombackground && runoptions.scaled > 200) bubble.zoomBackgroundImage();
			if (runoptions.showgrid) bubble.drawGrid();
			if (runoptions.selectedevent == SINGLEPARTICLE) bubble.setGraphics("drawbfield", "", 0, 0, 0, "");
			if (runoptions.selectedevent == HIGGSDECAY) bubble.clearCalorimeter();
		}

	public void loadExternalData() {

		String line = null;
		BufferedReader input = null;
		String name = new String();
 		float px=0, py=0, pz=0;
 		int counter=-1, i=0; 
 		
		try {

			System.out.println("Loading external data...");

			runoptions.selectedevent = EXTERNALDATA;
	 		bubble.changeEvent();
			input = new BufferedReader(new FileReader("bhdata/data.txt"));
			runoptions.b = -4;

			pcount = 0;
			while ((line = input.readLine()) != null) {
//				name = line.substring(0,bubble.stringContains(line,"\t"));
//				line = line.substring(1 + bubble.stringContains(line,"\t"));
//				px = Float.valueOf(line.substring(0,bubble.stringContains(line,"\t"))).floatValue();
//				line = line.substring(1 + bubble.stringContains(line,"\t"));
//				py = Float.valueOf(line.substring(0,bubble.stringContains(line,"\t"))).floatValue();
//				line = line.substring(1 + bubble.stringContains(line,"\t"));
//				pz = Float.valueOf(line.substring(0,bubble.stringContains(line,"\t"))).floatValue();

				name = line.substring(0,21).trim();
				px = Float.valueOf(line.substring(21,36).trim()).floatValue();
				py = Float.valueOf(line.substring(36,51).trim()).floatValue();
				pz = Float.valueOf(line.substring(51,67).trim()).floatValue();
				
				// Bad Programing to match Catfish names of particles to this code
				if (name.equals("K_L0")) name = "K0";
				if (name.equals("p+")) name = "p";
				if (name.equals("mu-")) name = "muon-";
				if (name.equals("mu+")) name = "muon+";

				i = bubble.findParticleName(name);
				counter++;
				if (i < 0) {
					System.out.println("Particle not found: " + name);
				}
				else {
					if (sqrt(px * px + py * py) < 5) {
//						System.out.println(counter + "  " + px + " " + py);
						runoptions.isbackground = true;
					}
					else runoptions.isbackground = false;
					bubble.createParticle(i, px, py, 0, 0);
					p[pcount].p[2] = pz;
					p[pcount].x[2] = 0;
					p[pcount].decaysinto = "";
				}
			}
			runoptions.isbackground = false;
			bubble.newRun();
		}
		catch (FileNotFoundException ex) {
			ex.printStackTrace();
		}
		catch (IOException ex){
			ex.printStackTrace();
		}

		finally {
			try {
				if (input != null) input.close();
	        }

	     	 catch (IOException ex) {
    	 	   ex.printStackTrace();
     		 }
		}

	}

	public void loadParticleList() {

		String line = null;
		BufferedReader input = null;
		int i=0;
		
		try {
			
			input = new BufferedReader(new FileReader("particle.lst"));
			spTextArea.append("Name\tMass\tCharge\tDecaylength\tVisible\n");

			while ((line = input.readLine()) != null) {
				
				line = line.replaceAll("\"", "");
				plist[i].name = line;
				line = input.readLine();
				plist[i].m = Float.valueOf(line);
				line = input.readLine();
				plist[i].q = Integer.valueOf(line);
				line = input.readLine();
				plist[i].decaylength = Float.valueOf(line);
				line = input.readLine();
				line = line.replaceAll("\"", "");
				plist[i].candecayinto = line;
				line = input.readLine();
				line = line.replaceAll("\"", "");
				if (line.equals("yes")) plist[i].makespath = true;
				else plist[i].makespath = false;
				spTextArea.append(plist[i].name + "\t" + Float.toString(plist[i].m) + "\t" + Integer.toString(plist[i].q) + "\t" + Float.toString(plist[i].decaylength) + "\t" + line + "\n");
				i++;				
			}
		}
	
		catch (FileNotFoundException ex) {
			ex.printStackTrace();
		}
		catch (IOException ex){
			ex.printStackTrace();
		}

		finally {
			try {
				if (input != null) input.close();
	        }

	     	 catch (IOException ex) {
    	 	   ex.printStackTrace();
     		 }
		}
	}	

	public void remoteExecution() {

		System.out.println("Automatic execution of external data started...");
		bubble.loadExternalData();
		while (!(runOrbitThread && runScreenThread)) {}
		long time = System.currentTimeMillis() + 20000;
		while (runOrbitThread || runScreenThread) {
		  if (time < System.currentTimeMillis()) {System.out.println("Operation timed out!"); break;}
		}
		System.out.println("Event has finished");
		bubble.saveImage("bhdata/event.jpg");
		System.exit(0);
	}

	private void setExternalTrue() {
	  external = true;
	}
	
	public int wavelengthToRGB(double wavelength) {
		double r, g, b;
		int farbe;
		
		if (wavelength >= 380 && wavelength < 440) {
			r = -(wavelength - 440) / (440 - 380);
			g = 0;
			b = 1.0;
		}
		else if(wavelength >= 440 && wavelength < 490) {
			r = 0.0;
			g = (wavelength - 440) / (490 - 440);
			b = 1.0;
		}
		else if(wavelength >= 490 && wavelength < 510) {
			r = 0.0;
			g = 1.0;
			b = -(wavelength - 510) / (510 - 490);
		}
		else if(wavelength >= 510 && wavelength < 580) {
			r = (wavelength - 510) / (580 - 510);
			g = 1.0;
			b = 0.0;
		}
		else if(wavelength >= 580 && wavelength < 645) {
			r = 1.0;
			g = -(wavelength - 645) / (645 - 580);
			b = 0.0;
		}
		else if(wavelength >= 645) { //&& wavelength <= 780) {
			r = 1.0;
			g = 0.0;
			b = 0.0;
		}
		else {
			return 0;
		}
		
		r = (r * 256) - 0.01;
		g = (g * 256) - 0.01;
		b = (b * 256) - 0.01;
		farbe = ((int)r * 65536) + ((int)g * 256) + (int)b;
		// System.out.println(farbe);
		return farbe;	
	
	}
		
	public void clearCalorimeter() {
		for (int i=0; i<ecal.length; ++i) {
			ecal[i] = 0;
		}
		
		for (int i=0; i<hcal.length; ++i) {
			hcal[i] = 0;
		}
		frmEcalWindow.updateCalorimeter();
		frmHcalWindow.updateCalorimeter();
	}
	
	public void assignSpecificColorsToParticles(int partNum) {
		// Method to temporarily assign specific colors to paricles
		// Should later be replaced by color assignment in particle list
		
		if (runoptions.selectedevent != HIGGSDECAY) return;
		if(p[partNum].type.equals("e") || p[partNum].type.equals("e-") || p[partNum].type.equals("e+")) {
		  p[partNum].farbe.r = 255;
		  p[partNum].farbe.g = 0;
		  p[partNum].farbe.b = 0;
		}
		if(p[partNum].type.equals("muon-") || p[partNum].type.equals("muon+") || p[partNum].type.equals("mu-") || p[partNum].type.equals("mu+")) {
		  p[partNum].farbe.r = 128;
		  p[partNum].farbe.g = 0;
		  p[partNum].farbe.b = 128;
		}
		if(p[partNum].type.equals("pi") || p[partNum].type.equals("pi-") || p[partNum].type.equals("pi+") || p[partNum].type.equals("jet")) {
		  p[partNum].farbe.r = 0;
		  p[partNum].farbe.g = 0;
		  p[partNum].farbe.b = 255;
		}
		if(p[partNum].type.equals("gamma")) {
		  p[partNum].farbe.r = 192;
		  p[partNum].farbe.g = 0;
		  p[partNum].farbe.b = 192;
		}
	}

	public double getBlackHoleMassAddition() {

		float lambda, range, yupbound, y;
	
		Random random = new Random();
		
		lambda = (float)0.004;  // original 0.0012
		range = 1000;
		yupbound = -1 / lambda * (float)(exp(-lambda * range) - 1);

		y = (float)(random.nextDouble() * yupbound);

		return (log(-lambda * y + 1)) / (-lambda);
}

	public static void main (String[] arg){

		bubble = new Bubble3();
//		bubble.setExternalTrue();
		bubble.init();
//		bubble.remoteExecution();
//		System.exit(0);
		
	}

	class MyCanvas extends JPanel {
	
		public MyCanvas() {};
	
		public void paintComponent(Graphics g) {
		
			canvasbuffer.newPixels();
			g.drawImage(pixelbuffer,0,0,null);
			if (mouse.mode == 2 && mouse.zoomclick == 1) {
				g.drawLine(zoom.x1, zoom.y1, zoom.x2, zoom.y1);
				g.drawLine(zoom.x2, zoom.y1, zoom.x2, zoom.y2);
				g.drawLine(zoom.x1, zoom.y2, zoom.x2, zoom.y2);
				g.drawLine(zoom.x1, zoom.y1, zoom.x1, zoom.y2);
			}		
		}
	}

	class MyMouseHandler extends MouseAdapter {
	
		public MyMouseHandler() {}
		
		public void mousePressed(MouseEvent e) {
			if (e.getSource() == aboutlblPicture) {
				if (e.getButton() == 3 && e.getClickCount() == 10) {
					bubble.loadExternalData();
				}
			}
		}
		
		public void mouseReleased(MouseEvent e) {
			for (int i=0; i<10; i++) {
				if (e.getSource() == lblEnergyTag[i]) {
					fpfd2txtEnergy.setText(lblEnergyTag[i].getText());
					frmFindHiggs.setVisible(true);
					break;
				}
			}
			if (e.getSource() == canvas) {
				switch (e.getButton()) {
					case 1:
							switch (mouse.mode) {
								case 1:
									if (mouse.counter == 0 && runoptions.selectedevent == LAMBDADECAY) {
										fpfdtxtMomentumx.setText("");
										fpfdtxtMomentumy.setText("");
										fpfdtxtRadius.setText("");
									} 
									circlefit.x[mouse.counter] = e.getX();
 									circlefit.y[mouse.counter] = e.getY();
 									bubble.setGraphics("cross", "red", e.getX(), e.getY(), 0, "");
									if (mouse.counter == 2) {
										if (runoptions.selectedevent == LAMBDADECAY) frmFindParticleFromDecay.setVisible(true);
										mouse.counter = 0;
										bubble.doFit();
									}
									else {mouse.counter++;};
									break;
								case 2:
								    if (mouse.zoomclick == 0) { 
										if (runScreenThread) return;
										zoom.x1 = e.getX();
										zoom.y1 = e.getY();
										zoom.x2 = zoom.x1;
										zoom.y2 = zoom.y1;
										mouse.zoomclick = 1;
										runScreenThread = true;
										RefreshScreenClass refreshScreen = new RefreshScreenClass();
										refreshScreen.start();
										break;
									}
									else {
										mouse.zoomclick = 0;
										runScreenThread = false;

             							int xspread, yspread, xcenter, ycenter;
             							
             							xspread = abs(zoom.x1 - zoom.x2);
             							yspread = abs(zoom.y1 - zoom.y2);
             							if(zoom.x1 < zoom.x2) xcenter = zoom.x1 + xspread / 2;
	           							else xcenter = zoom.x2 + xspread / 2;
             							if(zoom.y1 < zoom.y2) ycenter = zoom.y1 + yspread / 2;
	           							else ycenter = zoom.y2 + yspread / 2;
										if(xspread < yspread * 4 / 3) xspread = yspread * 4 / 3;
										else yspread = xspread * 4 / 3;
										runoptions.scaled = runoptions.scaled * 800 / xspread;
										runoptions.x0 = (runoptions.x0 - xcenter + 400) * 800 / xspread;
										runoptions.y0 = (runoptions.y0 - ycenter + 300) * 800 / xspread;
										bubble.rerun();
									}										
									break;
								case 3:
									if (mouse.counter == 0) {
										distance.x[0] = e.getX();
										distance.y[0] = e.getY();
										bubble.setGraphics("cross", "blue", distance.x[0], distance.y[0], 0, "");
										mouse.counter = 1;
										fpfdtxtDistanceTraveled.setText("");
									}
									else {
										distance.x[1] = e.getX();
										distance.y[1] = e.getY();
										bubble.setGraphics("cross", "blue", distance.x[1], distance.y[1], 0, "");
										distance.value = (float)sqrt((distance.x[0] - distance.x[1]) * (distance.x[0] - distance.x[1]) + (distance.y[0] - distance.y[1]) * (distance.y[0] - distance.y[1])) / runoptions.scaled;
										mouse.counter = 0;
										fpfdtxtDistanceTraveled.setText(Float.toString(distance.value));
										if (runoptions.selectedevent == LAMBDADECAY) frmFindParticleFromDecay.setVisible(true);
										else {
											MsgBox msgbox = new MsgBox("Distance", "Distance = " + Float.toString(distance.value) + " m");
										}
									}
									break;
								case 5:
									if (mouse.counter == 0) {
										fpfd2txtAngle.setText("");
										distance.x[0] = e.getX();
										distance.y[0] = e.getY();
										bubble.setGraphics("cross", "blue", e.getX(), e.getY(), 0 , "");
										mouse.counter = 1;
									}
									else {
										bubble.setGraphics("cross", "blue", e.getX(), e.getY(), 0 , "");
										if ((e.getX() - distance.x[0]) == 0) {
											if (distance.y[0] - e.getY() > 0) distance.value = 90;
											else if (distance.y[0] - e.getY() < 0) distance.value = 270;
											else {
												MsgBox msgbox = new MsgBox("Error", "Points Fall Together!");
												mouse.counter = 0;
												return;
											}
										}
										else {
											distance.value = (float)((atan((distance.y[0] - (float)e.getY()) / ((float)e.getX() - distance.x[0])) - (signum(e.getX() - distance.x[0]) - 1) * PI / 2) * 180 / PI);
										}
										fpfd2txtAngle.setText(Float.toString(distance.value));
										if (runoptions.selectedevent == HIGGSDECAY) frmFindHiggs.setVisible(true);
										mouse.counter = 0;
										if (!(runoptions.selectedevent == HIGGSDECAY)) {
											MsgBox msgbbox2 = new MsgBox("Angle", "Angle = " + Float.toString(distance.value));
										}
									}
									break;

							}
							break;
					case 3:
							runoptions.scaled = 200;
							runoptions.x0 = 0;
							runoptions.y0 = 0;
							bubble.rerun();
							break;
						
				}
			}
		}

		public void mouseClicked(MouseEvent e) {
			if (e.getSource() == canvas) {
//				bubble.setGraphics("cross", "black", e.getX(), e.getY(), 0, "");
			}
		}
		
	}
	
	class ButtonsHandler implements ActionListener {
		
		public ButtonsHandler() {}
		
		public void actionPerformed(ActionEvent e) {
			
			// Select event
			
			if (e.getSource() == bShuffleColors) {
				bubble.loadColors();
				return;
			}
			if (e.getSource() == bNewRun) {
				bubble.newRun();
				return;
			}
			if (e.getSource() == bRerun) {
				bubble.rerun();
				return;
			}
			if (e.getSource() == bStop) {
				bubble.Stop();
				return;
			}
			if (e.getSource() == bPpReset) {
				bubble.ppReset();
				return;
			}
			if (e.getSource() == bPpChamberReset) {
				bubble.ppChamberReset();
				return;
			}
			if (e.getSource() == bPpApply) {
				bubble.ppApply();
				return;
			}
			if (e.getSource() == bPpRun) {
				bubble.ppRun();
				return;
			}
			if (e.getSource() == selectcollisionschoices) {
				runoptions.selectedevent = selectcollisionschoices.getSelectedIndex();
				bubble.changeEvent();
				return;
			}
			if (e.getSource() == fpfdbtnAdd) {
				bubble.fpfdAdd();
				return;
			}
			if (e.getSource() == fpfdbtnRemove) {
				bubble.fpfdRemove();
				return;
			}
			if (e.getSource() == fpfdbtnClear) {
				bubble.fpfdClear();
				return;
			}
			if (e.getSource() == fpfdbtnCalculate) {
				bubble.fpfdCalculate();
				return;
			}
			if (e.getSource() == fpfd2btnAdd) {
				bubble.fpfd2Add();
				return;
			}
			if (e.getSource() == fpfd2btnRemove) {
				bubble.fpfd2Remove();
				return;
			}
			if (e.getSource() == fpfd2btnClear) {
				bubble.fpfd2Clear();
				return;
			}
			if (e.getSource() == fpfd2btnCalculate) {
				bubble.fpfd2Calculate();
				return;
			}
			if (e.getSource() == aboutbtnOk) {
				frmAbout.setVisible(false);
				return;
			}
			if (e.getSource() == comMomenta) {
				fpfdtxtRestmass.setText((String)comMomenta.getSelectedItem());
				bubble.fpfdtxtRestmassEnter();
				return;
			}
			if (e.getSource() == comMomenta2) {
				fpfd2txtMass.setText((String)comMomenta2.getSelectedItem());
				bubble.fpfdtxtRestmassEnter();
				return;
			}
		}
	}
	
	class MenubarHandler implements ActionListener {
		
		public MenubarHandler() {}
		
		public void actionPerformed(ActionEvent e) {

			// Select event
			
			if (e.getSource() == miProperties) {
				frmProperties.setVisible(true);
			}
			if (e.getSource() == miSaveImage) {
				FileDialog fd = new FileDialog(frame, "Save Image As...", FileDialog.SAVE);
				fd.show();
				bubble.saveImage(fd.getDirectory() + fd.getFile());
				fd.dispose();
			}
			if (e.getSource() == miQuit) {
//				frame.dispose();
				System.exit(0);
			}
			
			if (e.getSource() == miCirclefit) {
				bubble.turnOffMouse();
				Cursor hourglassCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
				canvas.setCursor(hourglassCursor);
				mouse.mode = 1;
			}
			if (e.getSource() == miZoom) {
				bubble.turnOffMouse();
				Cursor normalCursor = new Cursor(Cursor.DEFAULT_CURSOR);
				canvas.setCursor(normalCursor);
				mouse.mode = 2;
				return;
			}
			if (e.getSource() == miDistance) {
				bubble.turnOffMouse();
				Cursor normalCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
				canvas.setCursor(normalCursor);
				mouse.mode = 3;
				return;
			}
			if (e.getSource() == miIdentifyTrack) {
				bubble.turnOffMouse();
				Cursor normalCursor = new Cursor(Cursor.DEFAULT_CURSOR);
				canvas.setCursor(normalCursor);
				pnlFindParticle.setVisible(true);
				mouse.mode = 4;
				return;
			}
			if (e.getSource() == miAngle) {
				bubble.turnOffMouse();
				Cursor normalCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
				canvas.setCursor(normalCursor);
				mouse.mode = 5;
				return;
			}

			if (e.getSource() == miFindParticleFromDecay) {
				if (runoptions.selectedevent == HIGGSDECAY) {
					frmHcalWindow.setVisible(true);
					frmEcalWindow.setVisible(true);
					frmFindHiggs.setVisible(true);
				}
				else {
					frmFindParticleFromDecay.setVisible(true);
				}					
			}
			if (e.getSource() == miParticleLegend) {
				frmParticleLegend.setVisible(true);
			}
			if (e.getSource() == miViewSupportedParticles) {
				frmSupportedParticles.setVisible(true);
			}
			if (e.getSource() == miAbout) {
				frmAbout.setVisible(true);
				return;
			}
		}
		
	}
	
	class RefreshScreenClass extends Thread {
		
		public void run() {
			
			int a;
			
   			try{
   				while(runScreenThread) {
					super.sleep(20);
					canvas.repaint();
				}
			}
			catch(InterruptedException e) {}
		}
	}
	
	
	class Orbit extends Thread {

		int i;
		float []dp = new float [2];
		float b;
		int d;
		float dl;
		float pbefore;
		float dedx;
		float e;
		float pafter;
		float l;
		boolean display;
		int xpos;
		int ypos;
		int a;
		
		public void run () {

			runoptions.hasterminated = false;
			
			if (!runoptions.replay) {
				
				switch (runoptions.selectedevent) {
					case LAMBDADECAY:	
						pcount = -1;		
						createParticle(findParticleName("K-"), runoptions.inmomx, runoptions.inmomy, runoptions.inposx, runoptions.inposy);
						p[0].collideswith = "p";
						p[0].decaylength = (float)0.5;
						p[0].decaysinto = "pi-,lambda,pi+";
						break;
					case SINGLEPARTICLE:
           					int tempp;
           					float tempmom;
           					pcount = -1;
           					tempp = pnlSingleParticle.getListIndex();
           					if (tempp < 0) tempp = 0;
           					tempp = bubble.findParticleName(pnlSingleParticle.getListItem(tempp));
           					tempmom = pnlSingleParticle.getP();
           					if (tempmom <= 0.01 || tempmom > 10000) {
           						MsgBox msgbox = new MsgBox("Input Error", "<html><body>Specified Initial Momentum must be<br>between 0.01GeV/c and 10000Gev/c</body></html>");
           						bubble.Stop();
           						return;
           					}
           					bubble.createParticle(tempp, (float)0, tempmom, (float)(-1 * signum(runoptions.b* plist[tempp].q)), (float)-1.5);
           					p[0].decaylength = -1;
						break;
					case HIGGSDECAY:
						Random random = new Random();
						pcount = -1;
						String particleType;
						if (random.nextDouble() < 0.25) particleType = "bh";
						else particleType = "Higgs";
						bubble.createParticle(findParticleName(particleType), 0, 0, 0, 0);
						bubble.decayParticle(0);
						bubble.createBackground((float) bubble.getHiggsEnergy());
						p[0].decaylength = 0;
						break;
				}
			}
			else {
				for (i = 0; i <= pcount; i++) {
					p[i].x[0] = p[i].repx[0];
					p[i].x[1] = p[i].repx[1];
					p[i].p[0] = p[i].repp[0];
					p[i].p[1] = p[i].repp[1];
					p[i].m = plist[bubble.findParticleName(p[i].type)].m;
					p[i].isactive = true;
					p[i].dtraveled = 0;
					if (runoptions.selectedevent == HIGGSDECAY) p[0].isactive = false;					
				}
			}
			
			dedx = runoptions.dedx;
			// Step distance.
			dl = runoptions.dl;
			// Magnetic field.
			b = runoptions.b;
			int xpos;
			int ypos;
			float distance = 0;
			float stepping = runoptions.scaled;
			// Number of particles (1 = 0,1).
			
			while (runOrbitThread) {
			
				distance += dl;
			
				for (i = 0; i <= pcount; i++) {

					if (p[i].isactive) {

						if (runoptions.selectedevent == SINGLEPARTICLE) {
							if (p[i].x[0] > -1.25 && p[i].x[0] < 1.25 && p[i].x[1] > -0.75 && p[i].x[1] < 0.75) b = runoptions.b;
							else b = 0;
						}			
		
						pbefore = (float)sqrt(p[i].p[0] * p[i].p[0] + p[i].p[1] * p[i].p[1] + p[i].p[2] * p[i].p[2]);
				
						for (d = 0; d <= 1; d++) {
							dp[d] = p[i].q * b * p[i].p[1-d] / pbefore * dl * (1 - 2 * d) * (float)0.3;
							p[i].x[d] = p[i].x[d] + p[i].p[d] / pbefore * dl;
						}
						if (runoptions.selectedevent == EXTERNALDATA || runoptions.selectedevent == HIGGSDECAY) {
							p[i].x[2] = p[i].x[2] + dl * p[i].p[2] / pbefore;
							if (abs(p[i].x[2]) > 3) {
								p[i].isactive = false;
								bubble.showerEndcaps(i);
								bubble.checkForActiveParticles();
							}
						}							
				
						e = (float)sqrt(p[i].m * p[i].m + pbefore * pbefore);
						e = e - dedx * dl;
				
						if (e - p[i].m < 0) {
							p[i].isactive = false;
							bubble.checkForActiveParticles();
						}
				
						else {
							pafter = (float)sqrt(e * e - p[i].m * p[i].m);
						}
			
						for (d = 0; d <= 1; d++) {
							p[i].p[d] = (p[i].p[d] + dp[d]) * pafter / pbefore;
						}
				
						p[i].dtraveled = p[i].dtraveled + dl;
				
						if (p[i].decaylength >= 0 && p[i].dtraveled >= p[i].decaylength) {
							p[i].isactive = false;
							if (!runoptions.replay) bubble.decayParticle(i);
						}
			
						if (distance * stepping >= 1) {

							xpos = (int)(p[i].x[0] * runoptions.scaled + runoptions.x0 + 400);
							ypos = (int)(-p[i].x[1] * runoptions.scaled + runoptions.y0 + 300);
				
							if (xpos < 799 && xpos > -1 && ypos < 599 && ypos > -1) {
								if(p[i].makespath) pixels[ypos * 800 + xpos] = (255 << 24) |  (p[i].farbe.r << 16) |  (p[i].farbe.g << 8 ) | p[i].farbe.b;
							}
				
							else if (p[i].x[0] < -2 || p[i].x[0] > 2 || p[i].x[1] < -1.5 || p[i].x[1] > 1.5) { 
								p[i].isactive = false;
								bubble.checkForActiveParticles();
							}
						
						
							if (runoptions.selectedevent == HIGGSDECAY || runoptions.selectedevent == EXTERNALDATA) {
								if (bubble.checkForCalorimeter(xpos, ypos, i)) {
									p[i].isactive = false;
									bubble.checkForActiveParticles();
								}
							}
						}
						
					} // closes if
				} // closes for
			
				if (distance * stepping >= 1) distance = 0;

			} // closes while
			runoptions.hasterminated = true;
		}
	}

	class Runoptions {
		
		public Runoptions () {}
		
		public float inposx, inposy, inmomx, inmomy;
		public float dedx, b, dl, scaled, x0, y0;
		public boolean mustrunnew = true;
		public boolean showgrid = true;
		public boolean zoombackground = true;
		public boolean isbackground = true;
		public boolean replay = false;
		public boolean hasterminated = true;
		public int selectedevent;
		public String bgimage = new String();
		
	} 

	class Distance {
		
		public int[] x, y;
		public float value;

		public Distance () {
			x = new int[2];
			y = new int[2]; 
			}
		
	}
	
	class Circlefit {
		
		public float[] x, y, o, p;
		public float r;		
	
		public Circlefit () {
			x = new float[3];
			y = new float[3];
			o = new float[2];
			p = new float[2];
		}
	}

	class Mouse {
		
		public int counter, mode, zoomclick;
		
		public Mouse () {};
		
	}

	class Plist {
		
		public String name = new String();
		public String candecayinto = new String();
		public float m, decaylength;
		public int q;
		public boolean makespath;

		public Plist() {}

	}

	class P {
	
		public float[] x = new float[3];
		public float[] p = new float[3];
		public float[] repx = new float[3];
		public float[] repp = new float[3];
		public float m, decaylength, dtraveled;
		public int q;
		public String type = new String();
		public String decaysinto = new String();
		public String collideswith = new String();
		public boolean isactive, makespath, isbackground;
		public Farbe farbe = new Farbe();
	
		public P () {}
	
	}
	
	class Farbe {
		
		public int r,g,b;

		public Farbe () {}
		
	}
	
	class MsgBox {
		
		public MsgBox(String title, String message) {

			final JFrame frmMessage = new JFrame(title);
			frmMessage.setSize(new Dimension(200,100));
			frmMessage.setLayout(new FlowLayout());
			JPanel mainPanel = new JPanel();
			mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
			mainPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
			frmMessage.add(mainPanel);
			JPanel messagePanel = new JPanel();
			messagePanel.setLayout(new BorderLayout());
			JLabel lblMessage = new JLabel(message);
			messagePanel.add(lblMessage, BorderLayout.CENTER);
			mainPanel.add(messagePanel);
			mainPanel.add(Box.createRigidArea(new Dimension(0,10)));
			JPanel buttonPanel = new JPanel();
			buttonPanel.setLayout(new BorderLayout());
			JButton ok = new JButton("OK");
			ok.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					frmMessage.dispose();
				}
			});
			buttonPanel.add(ok, BorderLayout.CENTER);
			mainPanel.add(buttonPanel);
			frmMessage.setVisible(true);
			frmMessage.pack();
		}	
	}

	class FpfdList {
		
		float mass, momentumX, momentumY;
		
		public FpfdList() {}
		
	}

	class Fpfd2List {
		
		float mass, phi, energy, eta;
		
		public Fpfd2List() {}
		
	}

	class MyKeys implements KeyListener {
		
		public MyKeys() {}
		
		public void keyTyped(KeyEvent e) {}
		public void keyReleased(KeyEvent e) {}

		public void keyPressed(KeyEvent e) {
			int key = e.getKeyCode();
			if (key == KeyEvent.VK_ENTER) {
				if (e.getSource() == fpfdtxtRestmass || e.getSource() == fpfd2txtMass) {
					bubble.fpfdtxtRestmassEnter();
					return;
				}
			}
		}

	}
	
	class MyZoom {
		
		int x1, y1, x2, y2;
		
		public MyZoom() {}
		
	}

	class MyMouseMotionHandler extends MouseMotionAdapter {
		
		public MyMouseMotionHandler() {}
		
		public void mouseMoved(MouseEvent e) {
			if (mouse.mode == 2 && mouse.zoomclick == 1) {
				zoom.x2 = e.getX();
				zoom.y2 = e.getY();
			}
			if (mouse.mode == 4) bubble.movefindpart("move", e.getX(), e.getY());
		}

	}
	
	class IdentifyTrackClass extends JPanel {

		public JLabel lblFpType = new JLabel("Lambda");

		public IdentifyTrackClass() {
			this.setLayout(null);
			lblFpType.setOpaque(false);
			lblFpType.setBorder(BorderFactory.createLineBorder(Color.black));
			this.add(lblFpType);
			Insets insets = this.getInsets();
			lblFpType.setBounds(insets.left,insets.top,50,20);
		}
	
		public void moveTo(int x, int y) {
			Insets insets = canvas.getInsets();
			this.setBounds(x + insets.left,y + insets.top,61,31);
		}

		public void setText(String s) {
			lblFpType.setText(s);
		}

		public void paintComponent(Graphics g) {
			g.drawLine(50,20,60,30);
			g.drawLine(60,30,57,30);
			g.drawLine(60,30,60,27);		
		}

	}
	
	class SingleParticleClass extends JPanel {
		
		private JTextField txtSetP, txtMeasuredP, txtError, txtRadius;
		private JComboBox comParticle;

		public SingleParticleClass() {
			this.setLayout(null);
			this.setBorder(BorderFactory.createLineBorder(Color.black));
			this.setBackground(Color.white);
			Insets inset = this.getInsets();
			JLabel lblParticle = new JLabel("Particle:");
			this.add(lblParticle);
			lblParticle.setBounds(5 + inset.left, 5 + inset.top, 100, 16);
			JLabel lblSetP = new JLabel("Set p (GeV/c):");
			this.add(lblSetP);
			lblSetP.setBounds(5 + inset.left, 30 + inset.top, 100, 16);
			JLabel lblMeasuredP = new JLabel("Meas. p (GeV/c):");
			this.add(lblMeasuredP);
			lblMeasuredP.setBounds(5 + inset.left, 55 + inset.top, 100, 16);
			JLabel lblError = new JLabel("% error:");
			this.add(lblError);
			lblError.setBounds(5 + inset.left, 80 + inset.top, 100, 16);
			JLabel lblRadius = new JLabel("Radius (m):");
			this.add(lblRadius);
			lblRadius.setBounds(5 + inset.left, 105 + inset.top, 100, 16);
			txtSetP = new JTextField();
			txtSetP.setText("0.8");
			this.add(txtSetP);
			txtSetP.setBounds(100 + inset.left, 28 + inset.top, 74, 20);
			txtMeasuredP = new JTextField();
			txtMeasuredP.setEditable(false);
			this.add(txtMeasuredP);
			txtMeasuredP.setBounds(100 + inset.left, 53 + inset.top, 74, 20);
			txtError = new JTextField();
			txtError.setEditable(false);
			this.add(txtError);
			txtError.setBounds(100 + inset.left, 78 + inset.top, 74, 20);
			txtRadius = new JTextField();
			txtRadius.setEditable(false);
			this.add(txtRadius);
			txtRadius.setBounds(100 + inset.left, 103 + inset.top, 74, 20);
			comParticle = new JComboBox();
			comParticle.setBackground(Color.white);
			for (int i=0; i<lengthOfParticleList; i++) {
				if (!(plist[i].name.equals(""))) {
					comParticle.addItem(plist[i].name);
				}
				else break;
			}
			this.add(comParticle);
			comParticle.setBounds(100 + inset.left, 3 + inset.top, 74, 20);
		}
	
		public int getListIndex() {
			return comParticle.getSelectedIndex();		
		}
	
		public String getListItem(int i) {
			return (String)comParticle.getItemAt(i);
		}
		
		public float getP() {
			
			try {
				return Float.valueOf(txtSetP.getText()).floatValue();
			}
			catch (NumberFormatException e) {
				return 0;
			}
		}
		
		public void setMeasuredP(float p) {
			txtMeasuredP.setText(Float.toString(roundMe(p)));
		}
		
		public void setRadius(float r) {
			txtRadius.setText(Float.toString(roundMe(r)));
		}
		
		public void setError(float error) {
			txtError.setText(Float.toString(roundMe(error)));
		}
		
		public void clear() {
			txtError.setText("");
			txtRadius.setText("");
			txtMeasuredP.setText("");
		}
		
		private float roundMe(float temp) {
			temp *= 1000;
			return (float)(Math.round(temp) / 1000.0);
		}
	
	}
	
	class SingleParticleMessage extends JPanel {
		
		private int counter;
		private JLabel Message;
		
		public SingleParticleMessage() {
			counter = 0;
			this.setLayout(null);
//			this.setOpaque(false);
			this.setBackground(Color.white);
			this.setBorder(BorderFactory.createLineBorder(Color.black));
			Insets inset = this.getInsets();
			Message = new JLabel("Click on the new Run button to watch a particle bend in the magnetic field.");
			this.add(Message);
			Message.setBounds(5 + inset.left, 5 + inset.top, 500, 48);
		}
		
		public void nextMessage() {
			switch (counter) {
				case 0:
					Message.setText("<html><body>Click on three points on the track to fit a circle to the path of the particle. This will measure the momentum of the particle. The Value will be displayed in the Meas. p text box. Each measurement always has an error associated with it</html></body>");
					counter++;
					break;
				case 1:
					Message.setText("<html><body>Now change the momentum in the Set p Text field and click the New Run Button</body></html>");
					counter++;
					break;
				case 2:
					Message.setText("<html><body>You can see how the momentum affects the curvature since: p = q*b*r. Now change the particle type in the pull down menu to the right and click the New Run button. Here you can investigate the effects of different charges.");
					counter++;
					break;
				case 3:
					Message.setText("<html><body>Repeat these steps as often as you like and investigate the outcome.</body></html>");
					counter++;
					break;
			}
		}

		public void setCounter(int i) {counter = i;}
		
		public boolean isDisplayed() {
			if (counter < 0) return false;
			else return true;
		}
		
		public void hidePanel() {
			counter = -1;
			this.setVisible(false);
		}
		
	}

	class EnergyTag extends JLabel {
	
		public EnergyTag() {
			this.setBorder(BorderFactory.createLineBorder(Color.black));
			this.setOpaque(true);
			this.setBackground(Color.white);
			this.addMouseListener(hMouse);
		}
		
		public void setTag(int x, int y, float energy) {
			String s = Float.toString(energy);
			if (s.length() > 5) s = s.substring(0,5);
			this.setText(s);
			Insets inset = canvas.getInsets();
			canvas.add(this);
			this.setBounds(x -20 + inset.left, y - 9 + inset.top, 40, 18);
		}	

	}
	
	class ParticleLegend extends JPanel {
		
		int height = 0;
		
		public ParticleLegend() {
			this.setLayout(null);
		}
		
		public void addParticle(String particle, int red, int green, int blue) {
			Insets inset = this.getInsets();
			JLabel lblTemp = new JLabel(particle);
			lblTemp.setForeground(new Color(red, green, blue));
			this.add(lblTemp);
			lblTemp.setBounds(inset.left, height + inset.top, 200, 18);
			this.setBounds(0,0,200,height);
			height += 18;
		}
		
		public void clearPanel() {
			this.removeAll();
			this.repaint();
			height = 0;
		}
	}
	
	class CalorimeterWindow extends JFrame implements ActionListener, MouseMotionListener, MouseListener {
		
		private int width, height, zoomfactor = 1, xoffset = 0, yoffset = 0;
		private int pixelFlat[] = new int[640*480];
		private int pixel3D[] = new int[640*160];
		private int mouseMoveX, mouseMoveY, xshift = 0, yshift = 0;
		private float[] grid;
		private double scale = 1.0;
		private boolean showEnergySelectionGrid = true;
		private int gridSizeX = 2, gridSizeY = 2, selectedPixel = 0;
		private int xGridSpacing = 15, yGridSpacing = 15, xGridSpacingFlat = 15, yGridSpacingFlat = 15;  //32 48
		private int gridColor = (255 << 24) + (64 << 16) + (64 << 8) + 64;
		private int bgColor = (255 << 24) + (192 << 16) + (192 << 8) + 192;
		
		// Graphical elements
		private SpinnerNumberModel spinModelX, spinModelY;
		private JButton btnUpdate, btnZoomPlus, btnZoomMinus;
		private JButton btnScalePlus, btnScaleMinus;
		private JTextField txtEnergy, txtEta, txtPhi;
		private JLabel lblSensitivityScale;
		private JLabel lblPhiAxisFlat = new JLabel("\u03A6");
		//private JLabel lblPhiAxisFlatMin = new JLabel("<html><body>-&pi;</body></html>");
		private JLabel lblPhiAxisFlatMin = new JLabel("-\u03C0");
		private JLabel lblPhiAxisFlatMax = new JLabel("\u03C0");
		private JLabel lblEtaAxisFlat = new JLabel("pseudorapidity (\u03B7)");
		private JLabel lblEtaAxisFlatMin = new JLabel("-3");
		private JLabel lblEtaAxisFlatMax = new JLabel("3");
		private Insets pixelFlatCanvasInsets;
		
		private MemoryImageSource pixelFlatCanvasBuffer, pixel3DCanvasBuffer;	
		private Image pixelFlatBuffer, pixel3DBuffer;
		
		private MyCalorimeterCanvas pixelFlatCanvas, pixel3DCanvas;
		
		public CalorimeterWindow(String title, float[] gridReference, int widthReference) {
			this.setTitle(title);
			// this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			this.setSize(880,768);  //850 * 730
			this.setLayout(null);
			this.setVisible(false);
			
			grid = gridReference;
			width = widthReference;
			height = grid.length / width;

			pixelFlatCanvasBuffer = new MemoryImageSource(640, 480, pixelFlat, 0, 640);
			pixelFlatCanvasBuffer.setAnimated(true);
			pixelFlatCanvasBuffer.setFullBufferUpdates(true);
			pixelFlatBuffer = Toolkit.getDefaultToolkit().createImage(pixelFlatCanvasBuffer);

			pixel3DCanvasBuffer = new MemoryImageSource(640, 160, pixel3D, 0, 640);
			pixel3DCanvasBuffer.setAnimated(true);
			pixel3DCanvasBuffer.setFullBufferUpdates(true);
			pixel3DBuffer = Toolkit.getDefaultToolkit().createImage(pixel3DCanvasBuffer);

			pixelFlatCanvas = new MyCalorimeterCanvas(pixelFlatBuffer, pixelFlatCanvasBuffer);
			Insets inset = this.getInsets();
			pixelFlatCanvas.setBounds(10 + inset.left, 245 + inset.top, 640, 480);
			pixelFlatCanvas.addMouseMotionListener(this);
			pixelFlatCanvas.addMouseListener(this);
			pixelFlatCanvasInsets = pixelFlatCanvas.getInsets();
			pixelFlatCanvas.setLayout(null);
			this.add(pixelFlatCanvas);
			
			pixel3DCanvas = new MyCalorimeterCanvas(pixel3DBuffer, pixel3DCanvasBuffer);
			pixel3DCanvas.setBounds(10 + inset.left, 20 + inset.top, 640, 160);
			this.add(pixel3DCanvas);
			pixel3DCanvas.setLayout(null);

			JLabel lblCalorimeterTopView = new JLabel();
			lblCalorimeterTopView.setText("Calorimeter Top View:");
			lblCalorimeterTopView.setBounds(10 + inset.left, 222 + inset.top, 150,20);
			lblCalorimeterTopView.setVisible(true);
			this.add(lblCalorimeterTopView);
			
			btnZoomPlus = new JButton("+");
			btnZoomPlus.addActionListener(this);
			btnZoomPlus.setBounds(740 + inset.left, 20 + inset.top, 50, 20);
			this.add(btnZoomPlus);

			btnZoomMinus = new JButton("-");
			btnZoomMinus.addActionListener(this);
			btnZoomMinus.setBounds(800 + inset.left, 20 + inset.top, 50, 20);
			this.add(btnZoomMinus);

			btnScalePlus = new JButton("+");
			btnScalePlus.addActionListener(this);
			btnScalePlus.setBounds(740 + inset.left, 50 + inset.top, 50, 20);
			this.add(btnScalePlus);

			btnScaleMinus = new JButton("-");
			btnScaleMinus.addActionListener(this);
			btnScaleMinus.setBounds(800 + inset.left, 50 + inset.top, 50, 20);
			this.add(btnScaleMinus);
			
			spinModelX = new SpinnerNumberModel(1, 1, 9, 1);
			JSpinner spinnerGridX = new JSpinner(spinModelX);
			spinnerGridX.setBounds(670 + inset.left, 110 + inset.top, 50, 20);
			this.add(spinnerGridX);

			spinModelY = new SpinnerNumberModel(1, 1, 9, 1);
			JSpinner spinnerGridY = new JSpinner(spinModelY);
			spinnerGridY.setBounds(753 + inset.left, 110 + inset.top, 50, 20);
			this.add(spinnerGridY);
			
			JLabel lblZoom = new JLabel("Zoom:");
			lblZoom.setBounds(670 + inset.left, 20 + inset.top, 100, 20);
			this.add(lblZoom);
			
			JLabel lblSensitivity = new JLabel("Sensitivity:");
			lblSensitivity.setBounds(670 + inset.left, 50 + inset.top, 100, 20);
			this.add(lblSensitivity);

			JLabel lblEnergyBox = new JLabel("Energy Box Size (X x Y):");
			lblEnergyBox.setBounds(670 + inset.left, 80 + inset.top, 150, 20);
			this.add(lblEnergyBox);
			
			JLabel lblX = new JLabel("x");
			lblX.setBounds(734 + inset.left, 110 + inset.top, 20, 20);
			this.add(lblX);
			
			JLabel lblEta = new JLabel("Eta:");
			lblEta.setBounds(670 + inset.left, 140 + inset.top, 100, 20);
			this.add(lblEta);

			JLabel lblPhi = new JLabel("Phi (radians):");
			lblPhi.setBounds(670 + inset.left, 170 + inset.top, 100, 20);
			this.add(lblPhi);

			JLabel lblEnergy = new JLabel("Energy (GeV):");
			lblEnergy.setBounds(670 + inset.left, 200 + inset.top, 100, 20);
			this.add(lblEnergy);

			txtEta = new JTextField();
			txtEta.setBounds(765 + inset.left, 140 + inset.top, 86, 20);
			txtEta.addMouseListener(this);
			this.add(txtEta);
			
			txtPhi = new JTextField();
			txtPhi.setBounds(765 + inset.left, 170 + inset.top, 86, 20);
			txtPhi.addMouseListener(this);
			this.add(txtPhi);

			txtEnergy = new JTextField();
			txtEnergy.setBounds(765 + inset.left, 200 + inset.top, 86, 20);
			txtEnergy.addMouseListener(this);
			this.add(txtEnergy);

			btnUpdate = new JButton("Transfere Values");
			btnUpdate.addActionListener(this);
			btnUpdate.setBounds(690 + inset.left, 240 + inset.top, 140,20);

			Insets pixel3DCanvasInsets = pixel3DCanvas.getInsets();
			lblSensitivityScale = new JLabel("1000 GeV");
			lblSensitivityScale.setBounds(547 + pixel3DCanvasInsets.left, pixel3DCanvasInsets.top, 70, 20);
			lblSensitivityScale.setHorizontalAlignment(SwingConstants.RIGHT);
			pixel3DCanvas.add(lblSensitivityScale);
			
			JLabel lblPhiAxis = new JLabel("\u03A6");
			lblPhiAxis.setBounds(590 + pixel3DCanvasInsets.left, 117 + pixel3DCanvasInsets.top, 50, 20);
			pixel3DCanvas.add(lblPhiAxis);

			JLabel lblPhiAxisPiPlus = new JLabel("\u03C0");
			lblPhiAxisPiPlus.setBounds(630 + pixel3DCanvasInsets.left, 95 + pixel3DCanvasInsets.top, 50, 20);
			pixel3DCanvas.add(lblPhiAxisPiPlus);

			JLabel lblPhiAxisPiMinus = new JLabel("-\u03C0");
			lblPhiAxisPiMinus.setBounds(540 + pixel3DCanvasInsets.left, 138 + pixel3DCanvasInsets.top, 50, 20);
			pixel3DCanvas.add(lblPhiAxisPiMinus);

			JLabel lblEtaAxis3Plus = new JLabel("3");
			lblEtaAxis3Plus.setBounds(525 + pixel3DCanvasInsets.left, 145 + pixel3DCanvasInsets.top, 50, 20);
			pixel3DCanvas.add(lblEtaAxis3Plus);

			JLabel lblEtaAxis3Minus = new JLabel("-3");
			lblEtaAxis3Minus.setBounds(3 + pixel3DCanvasInsets.left, 145 + pixel3DCanvasInsets.top, 50, 20);
			pixel3DCanvas.add(lblEtaAxis3Minus);

			JLabel lblEtaAxis = new JLabel("pseudorapidity (\u03B7)");
			lblEtaAxis.setBounds(219 + pixel3DCanvasInsets.left, 143 + pixel3DCanvasInsets.top, 150, 20);
			pixel3DCanvas.add(lblEtaAxis);
			
			pixelFlatCanvas.add(lblPhiAxisFlat);
			pixelFlatCanvas.add(lblPhiAxisFlatMin);
			pixelFlatCanvas.add(lblPhiAxisFlatMax);
			pixelFlatCanvas.add(lblEtaAxisFlat);
			pixelFlatCanvas.add(lblEtaAxisFlatMin);
			pixelFlatCanvas.add(lblEtaAxisFlatMax);
			
			this.add(btnUpdate);
			drawPixelFlat();
			drawPixel3D();

		};
		
		private void drawPixel3D() {
			int x, y, farbe;

			// Clear Canvas
			for (int i=0; i<640*160; ++i) {
			  pixel3D[i] = 0xffffffff;	
			}
			
			// Set Label
			lblSensitivityScale.setText(String.valueOf((int)(1000 / scale)) + " GeV");
			
			// Draw Grid;
			int offset = (height - (int)(height / yGridSpacing / 2) * 2 * yGridSpacing) / 2;
			for (int h=offset; h<=height; h+=yGridSpacing) {
				y = 100 + (int)((double)(50 * h) / (double)height);
				x = (110 - (y - 100)*2);
				for (int i=0; i<520; i++) {
					pixel3D[640 * y + x + i] = gridColor;
				}
			}
			offset = (width - (int)(width / xGridSpacing / 2) * 2 * xGridSpacing) / 2;
			for (int l=offset; l<=width; l+=xGridSpacing) {
				y = 100;
				x = (110 - (y - 100)*2) + (int)((double)(520 * l) / (double)width);
				for (int h=0; h<50; h++) {
					pixel3D[640 * (100 + h) + x - h * 2] = gridColor;
				}
			}
			drawLine(630, 100, 630, 5, 0, pixel3D);
			drawLine(625, 70, 630, 70, 0, pixel3D);
			drawLine(625, 40, 630, 40, 0, pixel3D);
			drawLine(625, 10, 630, 10, 0, pixel3D);
								
			// Draw Histogram
			for (int h=0; h<height; ++h) {
				for (int l=0; l<width; ++l) {
					double gridValue = (double)grid[h * width + l];
					int gridHeight = (int)(gridValue / 10 * scale);
					if (gridValue > 0) farbe = (255 << 24) + bubble.wavelengthToRGB(gridValue * 0.22 * scale + 440);
					else farbe = bgColor;
					y = 100 + (int)((double)(50 * h) / (double)height);
					int ystretch = (int)((double)(50 * (h + 1)) / (double)height - (double)(50 * h) / (double)height + 0.99);
					x = (110 - (y - 100)*2) + (int)((double)(520 * l) / (double)width);
					int xstretch = (int)((double)(520 * (l + 1)) / (double)width - (double)(520 * l) / (double)width + 0.99);
					for (int dy=0; dy<ystretch; ++dy) {
						for (int dx=0; dx<xstretch; ++dx) {
							if (farbe == bgColor && pixel3D[640 * (y + dy) + x + dx - dy * 2] == gridColor);
							else {
								for (int iGridHeight=0; iGridHeight <= gridHeight; ++iGridHeight) {
									int addY = y + dy - iGridHeight;
									if(addY >= 0) pixel3D[640 * addY + x + dx - dy * 2] = farbe;
									else break;
								}
							}
						}
					}
				}
			}
			pixel3DCanvas.repaint();
		}
		
		private void drawPixelFlat() {
			int x, y, farbe;
			
			// clear canvas
			for (int i=0; i<640*480; ++i) {
			  pixelFlat[i] = 0xffffffff;	
			}
			
			//Set Labels
			lblPhiAxisFlat.setBounds(325 + xshift + zoomfactor * (width/2 + xoffset) + pixelFlatCanvasInsets.left, 231 + yshift + zoomfactor * yoffset + pixelFlatCanvasInsets.right, 50, 20);
			lblPhiAxisFlatMax.setBounds(325 + xshift + zoomfactor * (width/2 + xoffset) + pixelFlatCanvasInsets.left, 232 + yshift + zoomfactor * (yoffset - height/2) + pixelFlatCanvasInsets.right, 50, 20);
			lblPhiAxisFlatMin.setBounds(325 + xshift + zoomfactor * (width/2 + xoffset) + pixelFlatCanvasInsets.left, 225 + yshift + zoomfactor * (yoffset + height/2) + pixelFlatCanvasInsets.right, 50, 20);

			lblEtaAxisFlat.setBounds(268 + xshift + zoomfactor * xoffset + pixelFlatCanvasInsets.left, 237 + yshift + zoomfactor * (yoffset + height/2) + pixelFlatCanvasInsets.right, 150, 20);
			lblEtaAxisFlatMin.setBounds(313 + xshift + zoomfactor * (xoffset - width / 2) + pixelFlatCanvasInsets.left, 238 + yshift + zoomfactor * (yoffset + height/2) + pixelFlatCanvasInsets.right, 50, 20);
			lblEtaAxisFlatMax.setBounds(317 + xshift + zoomfactor * (xoffset + width / 2) + pixelFlatCanvasInsets.left, 238 + yshift + zoomfactor * (yoffset + height/2) + pixelFlatCanvasInsets.right, 50, 20);
			
			for (int h=0; h<height; ++h) {
				for (int l=0; l<width; ++l) {
					double gridValue = (double)grid[h * width + l];
					if (gridValue > 0) farbe = bubble.wavelengthToRGB(gridValue * 0.22 * scale + 440);
					else farbe = (255 << 24) + (192 << 16) + (192 << 8) + 192;
					for (int dh = 0; dh < zoomfactor; ++dh) {
						for (int dl = 0; dl < zoomfactor; ++dl) {
							x = 320 + xshift + zoomfactor * (l - width/2 + xoffset) + dl;
							if (x < 0 || x >= 640) break;
							y = 240 + yshift + zoomfactor * (h - height/2 + yoffset) + dh;
							if (y < 0 || y >= 480) break; 
							int pixelFlatPosition =  y * 640 + x;
							if (pixelFlatPosition >= 0 && pixelFlatPosition < 307200) pixelFlat[pixelFlatPosition] = (255 << 24) + farbe;
						}
					}
				}
			}
			
			// Draw Grid
			for (int h=height/2; h<=height; h+=yGridSpacingFlat) {
				for (int l=0; l<width; ++l) {
					for (int dl = 0; dl < zoomfactor; ++dl) {
						x = 320 + xshift + zoomfactor * (l - width/2 + xoffset) + dl;
						if (x < 0 || x >= 640) break;
						y = 240 + yshift + zoomfactor * (h - height/2 + yoffset);
						if (y >= 0 && y < 480) {
							int pixelFlatPosition =  y * 640 + x;
							if (pixelFlatPosition >= 0 && pixelFlatPosition < 307200) pixelFlat[pixelFlatPosition] = (255 << 24) + gridColor;
						}
						y = 240 + yshift + zoomfactor * (height/2 - h + yoffset);
						if (y >= 0 && y < 480) {
							int pixelFlatPosition =  y * 640 + x;
							if (pixelFlatPosition >= 0 && pixelFlatPosition < 307200) pixelFlat[pixelFlatPosition] = (255 << 24) + gridColor;
						}
					}
				}	
			}	 
			for (int l=width/2; l<=width; l+=yGridSpacingFlat) {
				for (int h=0; h<height; ++h) {
					for (int dh = 0; dh < zoomfactor; ++dh) {
						y = 240 + yshift + zoomfactor * (h - height/2 + yoffset) + dh;
						if (y >= 0 && y < 480) { 
							x = 320 + xshift + zoomfactor * (l - width/2 + xoffset);
							if (x >= 0 && x < 640) {
								int pixelFlatPosition =  y * 640 + x;
								if (pixelFlatPosition >= 0 && pixelFlatPosition < 307200) pixelFlat[pixelFlatPosition] = (255 << 24) + gridColor;
							}
							x = 320 + xshift + zoomfactor * (width/2 - l + xoffset);
							if (x >= 0 && x < 640) {
								int pixelFlatPosition =  y * 640 + x;
								if (pixelFlatPosition >= 0 && pixelFlatPosition < 307200) pixelFlat[pixelFlatPosition] = (255 << 24) + gridColor;
							}
						}
					}
				}	
			}	 
			
			// Draw Energy Selection Box
			if (showEnergySelectionGrid) {
				gridSizeX = spinModelX.getNumber().intValue();
				gridSizeY = spinModelY.getNumber().intValue();
				int pixelFlatPosition;
				int l = selectedPixel % width;
				int h = selectedPixel / width;
				l = 320 + xshift + zoomfactor * (l - width/2 + xoffset);
				h = 240 + yshift + zoomfactor * (h - height/2 + yoffset);
				for (int dx=0; dx < zoomfactor * gridSizeX; ++dx) {
					x = l + dx; y = h;
					pixelFlatPosition = y * 640 + x;
					if (x >= 0 && x < 640 && y >= 0 && y <480) pixelFlat[pixelFlatPosition] = (255 << 24);
					y = h + gridSizeY * zoomfactor - 1;
					pixelFlatPosition = y * 640 + x;
					if (x >= 0 && x < 640 && y >= 0 && y <480) pixelFlat[pixelFlatPosition] = (255 << 24);
				}
				for (int dy=0; dy < zoomfactor * gridSizeY; ++dy) {
					x = l; y = h + dy;
					pixelFlatPosition = y * 640 + x;
					if (x >= 0 && x < 640 && y >= 0 && y <480) pixelFlat[pixelFlatPosition] = (255 << 24);
					x = l + gridSizeX * zoomfactor - 1;
					pixelFlatPosition = y * 640 + x;
					if (x >= 0 && x < 640 && y >= 0 && y <480) pixelFlat[pixelFlatPosition] = (255 << 24);
				}			
			}
			pixelFlatCanvas.repaint();
		}
		
		public void updateCalorimeter() {
			drawPixelFlat();
			drawPixel3D();
		}
		
		public void actionPerformed(ActionEvent e){
			if (e.getSource() == btnUpdate) {
    			fpfd2txtEnergy.setText(txtEnergy.getText());
    			fpfd2txtAngle.setText(txtPhi.getText());
    			fpfd2txtEta.setText(txtEta.getText());	
			}
			if (e.getSource() == btnZoomPlus) {
				zoomfactor = zoomfactor * 2;
				xshift = xshift * 2;
				yshift = yshift * 2;
				drawPixelFlat();
			}
			if (e.getSource() == btnZoomMinus) {
				if (zoomfactor > 1) {
					zoomfactor = zoomfactor / 2;
					xshift = xshift / 2;
					yshift = yshift / 2;
					drawPixelFlat();
				}
			}
			if (e.getSource() == btnScalePlus) {
				scale = scale * 2;
				drawPixelFlat();
				drawPixel3D();
			}
			if (e.getSource() == btnScaleMinus) {
				if (scale > 1.0) {
					scale = scale / 2;
					drawPixelFlat();
					drawPixel3D();
				}
			}
    	}
 
		public void mouseMoved(MouseEvent e) {
			if (showEnergySelectionGrid) {
				int x = (int)((e.getX() - 320 - xshift - zoomfactor * (xoffset - width/2)) / zoomfactor);
				int y = (int)((e.getY() - 240 - yshift - zoomfactor * (yoffset - height/2)) / zoomfactor);
				if (selectedPixel != y * width + x && x >= 0 && x < width && y >= 0 && y < height) {
					selectedPixel = y * width + x;
					drawPixelFlat();
				}
			}
		}
		
		public void mouseDragged(MouseEvent e) {
			if (e.getSource() == pixelFlatCanvas) {
				xshift += e.getX() - mouseMoveX;
				yshift += e.getY() - mouseMoveY;
				mouseMoveX = e.getX();
				mouseMoveY = e.getY();
				drawPixelFlat();
			}
		}
    	
    	public void mouseExited(MouseEvent e) {
    	}
    	
    	public void mouseEntered(MouseEvent e) {
    	}
    	
    	public void mouseReleased(MouseEvent e) {
    	}
    	
    	public void mousePressed(MouseEvent e) {
    		if(e.getSource() == txtEnergy || e.getSource() == txtPhi || e.getSource() == txtEta) {
    			fpfd2txtEnergy.setText(txtEnergy.getText());
    			fpfd2txtAngle.setText(txtPhi.getText());
    			fpfd2txtEta.setText(txtEta.getText());	
    		}
    		if(e.getButton() == 1 && e.getSource() == pixelFlatCanvas) {
    			mouseMoveX = e.getX();
    			mouseMoveY = e.getY();
				int x = selectedPixel % width;
				int y = selectedPixel / width;
				double energy = 0, xEnergyAverage = 0, yEnergyAverage = 0;
				for (int dy=0; dy<gridSizeY; ++dy) {
					for (int dx=0; dx<gridSizeX; ++dx) {
						if (x + dx >=0 && x + dx < width && y + dy >=0 && y + dy < height) {
							float energyAddition = grid[(y + dy) * width + x + dx];
							energy += energyAddition;
							xEnergyAverage += energyAddition * dx;
							yEnergyAverage += energyAddition * dy;
						}
					}
				}
				if (energy == 0) {
					xEnergyAverage = 0;
					yEnergyAverage = 0;
				}
				else {
					xEnergyAverage = xEnergyAverage / energy;
					yEnergyAverage = yEnergyAverage / energy;
				}
				double xpos =  x + xEnergyAverage;
				double ypos = y + yEnergyAverage;
				
				double eta, phi, px, py, pz, pvalue;
				eta = (xpos + 0.5  - width / 2) / width * 6;
				phi = (height / 2 - ypos - 0.5) / height * 2 * PI;
				pz = energy * (exp(2*eta) - 1) / (exp(2*eta) + 1);
				pvalue = sqrt(energy * energy - pz * pz);
				px = cos(phi) * pvalue;
				py = sin(phi) * pvalue;
				
				txtEta.setText(Float.toString((float)eta));
				txtPhi.setText(Float.toString((float)phi));
				txtEnergy.setText(Float.toString((float)energy));
    		}
    	}
    	
    	public void mouseClicked(MouseEvent e) {
    	}
    	
    	public void setGridSpacing3D(int gridX, int gridY) {
    		xGridSpacing = gridX;
    		yGridSpacing = gridY;
    		drawPixel3D();
    	}
    	
    	public void setGridSpacingFlat(int gridX, int gridY) {
    		xGridSpacingFlat = gridX;
    		yGridSpacingFlat = gridY;
    		drawPixelFlat();
    	}
    	
    	public void setZoom(int zoom) {
    		zoomfactor = zoom;
    		drawPixelFlat();
    	}
    	
    	public void setEnergySelectionGridSize(int xSize, int ySize) {
    		spinModelX.setValue(new Integer(xSize));
    		spinModelY.setValue(new Integer(ySize));
    	}
    	
    	private void drawLine(int xStart, int yStart, int xStop, int yStop, int color, int[] screen) {
			float stepping = (float)(1/sqrt(pow(xStart - xStop, 2.) + pow(yStart - yStop, 2.)));
			for (float a=0; a<=1; a+=stepping) {
				setPixel((int)(xStart + (xStop - xStart) * a + 0.5), (int)(yStart + (yStop - yStart) * a + 0.5), color, screen);
			}
    	}
    	
    	private void setPixel(int x, int y, int color, int[] screen) {
    		screen[y * 640 + x] = (255 << 24) + color;
    	}
    	
	}

	class MyCalorimeterCanvas extends JPanel {

		private Image pixelBuffer;
		private MemoryImageSource canvasBuffer;
	
		public MyCalorimeterCanvas(Image pixelBufferReference, MemoryImageSource canvasBufferReference) {
		  pixelBuffer = pixelBufferReference;
		  canvasBuffer = canvasBufferReference;
		};
	
		public void paintComponent(Graphics g) {
		
			canvasBuffer.newPixels();
			g.drawImage(pixelBuffer,0,0,null);
		}
	}
	
	class MuonTag extends JLabel implements MouseListener {
	
		private double eta, phi, energy;
		
		public MuonTag() {
			this.setBorder(BorderFactory.createLineBorder(Color.black));
			this.setOpaque(true);
			this.setBackground(Color.white);
			this.addMouseListener(this);
		}
		
		public void setTag(int x, int y, double energyRef, double etaRef, double phiRef) {
			String s = Double.toString(energyRef);
			if (s.length() > 5) s = s.substring(0,5);
			this.setText(s);
			Insets inset = canvas.getInsets();
			canvas.add(this);
			this.setBounds(x -20 + inset.left, y - 9 + inset.top, 40, 18);
			eta = etaRef;
			phi = phiRef;
			energy = energyRef;
		}	

    	public void mouseExited(MouseEvent e) {
    	}
    	
    	public void mouseEntered(MouseEvent e) {
    	}
    	
    	public void mouseReleased(MouseEvent e) {
    	}
    	
    	public void mousePressed(MouseEvent e) {
    		fpfd2txtEnergy.setText(Float.toString((float)energy));
    		fpfd2txtAngle.setText(Float.toString((float)phi));
    		fpfd2txtEta.setText(Float.toString((float)eta));	
    	}
    	
    	public void mouseClicked(MouseEvent e) {
    	}
    	
	}

		
}